// #autoload
// #name = DEDEN Demo Advanced
// #version = 0.6.0
// #date = December 4, 2001
// #status = Beta
// #description = Advanced demo features
// #author = ]S[DEDEN
// #warrior = DEDEN
// #email = warpath@strategyplanet.com
// #config = DEDDemoAdvancedConfigGUI
// #category = DEDEN Script
// #include = support/player_support.cs
// #include = support/mission_callbacks.cs
// #readme = scripts/autoexec/DEDDemoAdvanced.txt

package DEDDemoAdvanced {

//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Support Functions
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function DEDDemoAdvancedSetDefaults() {
		$DemoFileSnapshot = "";
		$DEDDemoAdvanced::OutputtingScreenShots = false;
		$DEDDemoAdvanced::ToggleSafetyMode = false;
		$DEDDemoAdvanced::Recording = false;
		$DEDDemoAdvanced::CurrentPath = "";
		$DEDDemoAdvanced::FilterList = "";
		$DEDDemoAdvanced::FilterList[0] = "No Filter";
		$DEDDemoAdvanced::LastFilter = 0;
		$DEDDemoAdvanced::NumFilters = 0;
		$DEDDemoAdvanced::LastDemoFileNumber = 0;
		$DEDDemoAdvanced::LastDemoFileName = "";
		$DEDDemoAdvanced::OutputLock = false;

		$DEDDemoAdvanced::TextPrefix = 1;
		$DEDDemoAdvanced::PlayerName = 0;
		$DEDDemoAdvanced::ServerName = 0;
		$DEDDemoAdvanced::MissionName = 0;
		$DEDDemoAdvanced::GameType = 0;
		$DEDDemoAdvanced::TeamName = 0;

		$DEDDemoAdvanced::TextPrefixDir = 0;
		$DEDDemoAdvanced::PlayerNameDir = 0;
		$DEDDemoAdvanced::ServerNameDir = 0;
		$DEDDemoAdvanced::MissionNameDir = 0;
		$DEDDemoAdvanced::GameTypeDir = 0;
		$DEDDemoAdvanced::TeamNameDir = 0;
			
		$DEDDemoAdvanced::Prompt = 0;
		$DEDDemoAdvanced::AlwaysRecordTournaments = 0;
		$DEDDemoAdvanced::AutomaticSafetyMode = 0;
		$DEDDemoAdvanced::TextPrefixText = "Demo";
		$DEDDemoAdvanced::TextPrefixDirText = "";

		$DEDDemoAdvanced::ShowRecordHUD = 0;
		$DEDDemoAdvanced::ShowRecordHUDBlink = 0;
		$DEDDemoAdvanced::RecordOnMapStart = 0;
		$DEDDemoAdvanced::StopAtMapEnd = 0;
		$DEDDemoAdvanced::ShowScores = 0;
		$DEDDemoAdvanced::NoSnapShotHUDs = 0;
		$DEDDemoAdvanced::TakeSnapshots = 0;
		$DEDDemoAdvanced::SnapshotAt = "Map Start";
		
		$DEDDemoAdvanced::FPS = 30;
		$DEDDemoAdvanced::OutputChangeRes = false;
		$DEDDemoAdvanced::OutputMuteSounds = false;
		$DEDDemoAdvanced::OutputNoHUDS = false;
		
		$DEDDemoAdvanced::EnableAudioAlerts = 0;
		$DEDDemoAdvanced::DeleteSound = "DDA_None_Del";
		$DEDDemoAdvanced::SafetySound = "DDA_None_Saf";
		$DEDDemoAdvanced::StartSound = "DDA_None_On";
		$DEDDemoAdvanced::StopSound = "DDA_None_Off";
			
		$DEDDemoAdvanced::StartRecord = "DDA_Basic_On";
		$DEDDemoAdvanced::StopRecord = "DDA_Basic_Off";
		
		$DEDDemoAdvanced::AddedHUDToList = false;
		$DEDDemoAdvanced::RecordingHudSize = 1.0;
		$DEDDemoAdvanced::RecordingHudX = 42;
		$DEDDemoAdvanced::RecordingHudY = 25;
		
		$DEDDemoAdvanced::GammaCorrection = $pref::OpenGL::gammaCorrection;
		$DEDDemoAdvanced::ShowCurrentGamma = 0;
	}

	function DEDDemoAdvancedLoadPrefs() {
		if(!isfile("prefs/DEDDemoAdvancedPrefs.cs")) {
			echo("DEDDemoAdvanced Preferences not found -- Setting Defaults");
			DEDDemoAdvancedSavePrefs();
		} else
			exec("prefs/DEDDemoAdvancedPrefs.cs");
	}

	function DEDDemoAdvancedSavePrefs() {
		echo("Saving DEDDemoAdvanced Preferences...");
		%sc = $script["DEDDemoAdvanced.cs"];

		$DEDDemoAdvanced = new FileObject();
		$DEDDemoAdvanced.openForWrite("prefs/DEDDemoAdvancedPrefs.cs");
		$DEDDemoAdvanced.writeline("//----------------------------------------------------------------------------------");
		$DEDDemoAdvanced.writeline("// " @ %sc.name @ " Preferences File");
		$DEDDemoAdvanced.writeline("// Generated by " @ %sc.name @ " V" @ %sc.versionString @ " " @ %sc.statusString);
		$DEDDemoAdvanced.writeline("//----------------------------------------------------------------------------------");
		$DEDDemoAdvanced.writeline("");
		$DEDDemoAdvanced.close();
		$DEDDemoAdvanced.delete();
		$DEDDemoAdvanced = "";
		
		export("$DEDDemoAdvanced::*", "prefs/DEDDemoAdvancedPrefs.cs", True);
	}

	function DEDDemoAdvancedSetup(){
		
		if (!isFile("Textures/Snapshots/")) {
			$DEDDemoAdvanced = new FileObject();
			$DEDDemoAdvanced.openForWrite("Textures/Snapshots/");
			$DEDDemoAdvanced.close();
			$DEDDemoAdvanced.delete();
			$DEDDemoAdvanced = "";
		}
		
		if (!isFile("Sequenced Images/")) {
			$DEDDemoAdvanced = new FileObject();
			$DEDDemoAdvanced.openForWrite("Sequenced Images/");
			$DEDDemoAdvanced.close();
			$DEDDemoAdvanced.delete();
			$DEDDemoAdvanced = "";
		}

		if (!$DEDDemoAdvanced::DeleteBind) {
			$RemapName[$RemapCount] = "Delete Last Demo";
			$RemapCmd[$RemapCount]  = "DEDDemoAdvancedDeleteLastDemo";
			$RemapCount++;
			$DEDDemoAdvanced::DeleteBind = true;
		}

		DEDDemoAdvancedSetDefaults();
		DEDDemoAdvancedLoadPrefs();
		
		$DEDDemoAdvanced::LastDemoFileNumber = 0;
		$DEDDemoAdvanced::NumFilters = 0;
		$DEDDemoAdvanced::NumPathList = 0;
		$DEDDemoAdvanced::PathList = "";
		$DEDDemoAdvanced::Recording = 0;
		$DEDDemoAdvanced::OutputtingScreenShots = false;
	
		DEDDemoAdvancedGetDirectoryStructure();
		DEDDemoRecordingHudDelete();
	}








//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Directory Support
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function DEDDemoAdvancedGetDirectoryStructure() {
		$DEDDemoAdvanced::PathList = "";
		$DEDDemoAdvanced::NumPathList = 0;
		
		%search = "recordings/*.rec";

		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
      			%fileName = fileBase(%file);
      			
      			%var = StrStr(%file, %fileName) - 11;
      			%path = getSubStr(%file, 11, %var);
      			
      			if (%path !$= "") {
      				%pathFound = false;
      				for (%i = 0; %i < $DEDDemoAdvanced::NumPathList; %i++) {
      					if (%path $= $DEDDemoAdvanced::PathList[%i])
      						%pathFound = true;
				}
				
				if (!%pathFound) {
					$DEDDemoAdvanced::PathList[$DEDDemoAdvanced::NumPathList] = %path;
					$DEDDemoAdvanced::NumPathList++;
					
					if (StrStr(%path, "/") != -1) {
						for (%i = StrLen(%path); %i > 0; %i--) {
							if (GetSubStr(%path,%i,1) $= "/") {
	      							%pathFound = false;
      								for (%j = 0; %j < $DEDDemoAdvanced::NumPathList; %j++) {
      									if (GetSubStr(%path,0,%i+1) $= $DEDDemoAdvanced::PathList[%j])
      										%pathFound = true;
								}
					
								if (!%pathFound) {
									$DEDDemoAdvanced::PathList[$DEDDemoAdvanced::NumPathList] = GetSubStr(%path,0,%i+1);
									$DEDDemoAdvanced::NumPathList++;
								}
							}
						}
					}
				}
			}
		}		
	}

	function DEDDemoAdvancedCheckDirLevel(%val) {
		%pathCheck = "recordings/" @ $DEDDemoAdvanced::CurrentPath;
		if (%val !$= "") {
			if (StrStr(%val, %pathCheck) != -1) {
				%newStr = GetSubStr(%val, StrLen(%pathCheck), StrLen(%val)-StrLen(%pathCheck));
				%pos = StrStr(%newStr, "/");
				if (%val $= %pathCheck)
					return false;
					
				if (%pos == -1 || %pos == StrLen(%newStr)-1 && %val !$= %pathCheck)
					return true;
				else
					return false;
			}
		} else
			return false;
	}

	function DEDDemoAdvancedPreviousDirectory() {
		RecordingsDlgList.setSelectedRow(0);		
		%sel = RecordingsDlgList.getSelectedId();
  		%rowText = RecordingsDlgList.getRowTextById(%sel);

   		%pname = getField(%rowText,3);
		$DEDDemoAdvanced::CurrentPath = %pname;
		RecordingsDlg::fillRecordingsList(RecordingsDlg);
		DEDDemoAdvancedDirectoryDropDownUpdate(%pname);
	}









//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Make Directory
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function doMakeDirectory() {
		%dirName = DEDDemoAdvancedMakeDirectory_Edit.getValue();
		$DEDDemoAdvanced = new FileObject();
		$DEDDemoAdvanced.openForWrite("recordings/" @ $DEDDemoAdvanced::CurrentPath @ "" @ %dirName @ "/");
		$DEDDemoAdvanced.close();
		$DEDDemoAdvanced.delete();
		$DEDDemoAdvanced = "";

		$DEDDemoAdvanced::PathList[$DEDDemoAdvanced::NumPathList] = $DEDDemoAdvanced::CurrentPath @ "" @ %dirName @ "/";
		DEDDemoAdvancedDirectoryDropDown.add( "recordings/" @ $DEDDemoAdvanced::PathList[$DEDDemoAdvanced::NumPathList], $DEDDemoAdvanced::NumPathList+1, 1 );
		$DEDDemoAdvanced::NumPathList++;

		RecordingsDlg::fillRecordingsList(RecordingsDlg);
		DEDDemoAdvancedDirectoryDropDownUpdate(%pname);
	}
	
	function DEDDemoAdvancedMakeDirectory() {
		DEDDemoAdvancedMakeDirectory_Edit.setValue(%file);
   			Canvas.pushDialog(DEDDemoAdvancedMakeDirectoryDlg);
	}












//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Recording HUD
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function DEDDemoRecordingHudCreate() {
		if (!isObject(DEDDemoRecordingHud)) {
			%xyPos = $DEDDemoAdvanced::RecordingHudX @ " " @ $DEDDemoAdvanced::RecordingHudY;
		
			new HudBitmapCtrl(DEDDemoRecordingHud) {
				profile = "GuiButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "0 0";
				extent = %xyPos;
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				fillColor = "0.250000 0.250000 0.250000 0.250000";
				frameColor = "0.000000 1.000000 0.000000 1.000000";
				opacity = "0.9";
				bitmap = "gui/" @ $DEDDemoAdvanced::StartRecord @ "";
				autoCenter = "0";
				autoResize = "0";
				flipVertical = "0";
				flipHorizontal = "0";
			};

			PlayGui.add(DEDDemoRecordingHud);
			if (isObject(HudMover)) {
				if (!$DEDDemoAdvanced::AddedHUDToList) {
					hudmover::addhud(DEDDemoRecordingHud, "DEDEN Recording HUD");
					$DEDDemoAdvanced::AddedHUDToList = true;
				}

				%px = getWord($hudposDEDDemoRecordingHud, 0);
				%py = getWord($hudposDEDDemoRecordingHud, 1);
				if (isObject(DEDDemoRecordingHud)) {
					DEDDemoRecordingHud.setposition(%px, %py);
					DEDDemoRecordingHud.setExtent($DEDDemoAdvanced::RecordingHudX, $DEDDemoAdvanced::RecordingHudY);
				}
			}
		}
	}


	function DEDDemoRecordingHudDelete() {
		if (isObject(DEDDemoRecordingHud)) {
			playGui.remove(DEDDemoRecordingHud);
			DEDDemoRecordingHud.delete();
		}
	}


	function clientCmdTogglePlayHuds(%val) {
		parent::clientCmdTogglePlayHuds(%val);
		if ($DEDDemoAdvanced::ShowRecordHUD) 
			DEDDemoRecordingHud.setVisible(%val);
	}

	function DEDDemoAdvancedFlashRecordingHud() {
		if ($DEDDemoAdvanced::ShowRecordHUD) {
			if ($DEDDemoAdvanced::ShowRecordHUDBlink) {
				if ($DEDDemoAdvanced::FlashHUD != 0) {
					DEDDemoRecordingHud.setBitmap("gui/" @ $DEDDemoAdvanced::StartRecord @ "");
					$DEDDemoAdvanced::FlashHUD = 0;
				} else {
					DEDDemoRecordingHud.setBitmap("gui/" @ $DEDDemoAdvanced::StopRecord @ "");
					$DEDDemoAdvanced::FlashHUD = 1;
				}
			} else
				DEDDemoRecordingHud.setBitmap("gui/" @ $DEDDemoAdvanced::StartRecord @ "");

			if ($DEDDemoAdvanced::Recording) {
				schedule( 800, 0, "DEDDemoAdvancedFlashRecordingHud" );
			} else {
				DEDDemoRecordingHudDelete();
				$DEDDemoAdvanced::FlashHUD = 0;
			}
		}
	}

	function DEDDemoAdvancedClientDrop() {
		DEDDemoRecordingHudDelete();
	}
	
 	function DEDDemoAdvanced_SetRecordingHudSize() {
 		$DEDDemoAdvanced::RecordingHudSize = DEDDemoAdvanced_RecordingHudSize.getValue();
 		
		$DEDDemoAdvanced::RecordingHudX = mFloor(42 * $DEDDemoAdvanced::RecordingHudSize) -1;
		$DEDDemoAdvanced::RecordingHudY = mFloor(25 * $DEDDemoAdvanced::RecordingHudSize) -1;
		
		DEDDemoAdvancedOnIcon.setExtent($DEDDemoAdvanced::RecordingHudX, $DEDDemoAdvanced::RecordingHudY);
		DEDDemoRecordingHud.setExtent($DEDDemoAdvanced::RecordingHudX, $DEDDemoAdvanced::RecordingHudY);
	}










//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Sequenced Image Output
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function recordMovie(%movieName, %fps) {
		$timeAdvance = 1000 / %fps + 6;
				
		if ($DEDDemoAdvanced::OutputBatchFile) {
			%sc = $script[DEDDemoAdvanced.cs];
		
			%filecount = 0;
			for(%found = true; %found; %filecount++ ) {
				%suffix = %filecount;
				while (strlen(%suffix) < 5) %suffix = "0" @ %suffix;
				%fileName = "Sequenced Images/Generate_Movie" @ %suffix @ ".bat";
				%found = isFile(%fileName);
			}
			
			$DEDDemoAdvanced::SeqFileName = %fileName;			

			$DEDDemoAdvanced = new FileObject($DEDDemoAdvanced::SeqFileName);
			$DEDDemoAdvanced.openForWrite();
			$DEDDemoAdvanced.writeline("@echo off");
			$DEDDemoAdvanced.writeline("echo DEDEN's Demo Advanced AVI Creation File");
			$DEDDemoAdvanced.writeline("echo Generated by DEDEN's Demo Advanced V" @ %sc.versionString @ " " @ %sc.statusString);
			$DEDDemoAdvanced.writeline("echo");
			$DEDDemoAdvanced.writeline("");
			$DEDDemoAdvanced.close();
			$DEDDemoAdvanced.delete();
			$DEDDemoAdvanced = "";
		}
		
		movieGrabScreen(%movieName, 0);
	}

	function DDA_ToggleOutputHUDS(%val) {
		//ammoHud.setVisible(%val);
		//objectiveHud.setVisible(%val);
		//inventoryHud.setVisible(%val);
		//if(backpackFrame.pack)
		//	backpackFrame.setVisible(%val);
		//weaponsHud.setVisible(%val);
		//retCenterHud.setVisible(%val);
		//HudClusterBack.setVisible(%val);
		//outerChatHud.setVisible(%val);
		//clockHud.setVisible(%val);
		
		if ($DEDDemoAdvanced::OutputPanorama) {
			if (!%val) {
				Canvas.setContent(PanoramaGui);
				PanoramaGui.beaconsVisible = false;
				if ($cursorControlled) 
					lockMouse(true);

				Canvas.cursorOff();
				$pref::interior::showdetailmaps = false;
			}
		} else 
			Canvas.setContent(PlayGui);

		if(!$DEDDemoAdvanced::OutputShowClientWaypoint)
      			navHud.setMarkerTypeVisible(ClientWaypoint, %val); 

      		if(!$DEDDemoAdvanced::OutputShowMissionWaypoint)	
      			navHud.setMarkerTypeVisible(MissionWaypoint, %val);

		if(!$DEDDemoAdvanced::OutputShowTargets)
			navHud.setMarkerTypeVisible(Target, %val);

		if(!$DEDDemoAdvanced::OutputShowPotentialTask)
			navHud.setMarkerTypeVisible(PotentialTask, %val);

		if(!$DEDDemoAdvanced::OutputShowAssignedTask)
			navHud.setMarkerTypeVisible(AssignedTask, %val);

		if(!$DEDDemoAdvanced::OutputShowBeacons)
			PlayGui.beaconsVisible = %val;
	}

	function movieGrabScreen(%movieName, %frameNumber) {
		if(%frameNumber < 10)
			%frameNumber = "0" @ %frameNumber;
		if(%frameNumber < 100)
			%frameNumber = "0" @ %frameNumber;
		if(%frameNumber < 1000)
			%frameNumber = "0" @ %frameNumber;
		if(%frameNumber < 10000)
			%frameNumber = "0" @ %frameNumber;

		if ($DEDDemoAdvanced::OutputNoHUDS) {
			Canvas.setContent(PanoramaGui);
			PanoramaGui.beaconsVisible = false;
			if ($cursorControlled) 
				lockMouse(true);

			Canvas.cursorOff();
			$pref::interior::showdetailmaps = false;
		}

		//DDA_ToggleOutputHUDS(false);

		if ($DEDDemoAdvanced::OutputBatchFile) {
			$DEDDemoAdvanced = new FileObject();
			$DEDDemoAdvanced.openForAppend($DEDDemoAdvanced::SeqFileName);
			$DEDDemoAdvanced.writeline("tools\abc " @ %movieName @ %frameNumber @ ".png /convert=" @ %movieName @ %frameNumber @ ".tga");
			//$DEDDemoAdvanced.writeline("del " @ %movieName @ %frameNumber @ ".png");
			$DEDDemoAdvanced.close();
			$DEDDemoAdvanced.delete();
			$DEDDemoAdvanced = "";
		}
		screenshot(%movieName @ %frameNumber @ ".png");

		//DDA_ToggleOutputHUDS(true);

		if (!$DEDDemoAdvanced::OutputNoHUDS)
			Canvas.setContent(PlayGui);

		$screenGrabThread = schedule($timeAdvance, 0, "movieGrabScreen", %movieName, (%frameNumber + 1));
	}

	function stopMovie() {
		cancel($screenGrabThread);
	}

	function DEDDemoAdvancedStopDemoOutputting() {
		if ($DEDDemoAdvanced::SnapshotAt $= "Output End") {
			if(!isFile("textures/snapshots/" @ $DEDDemoAdvanced::CurrentDemoFile @ ".png")) {
				DEDDemoAdvancedReplaceSnapshot();
			}
		}

		cancel($DEDDemoAdvancedSchedule);
		stopDemoPlayback();
	}

	function DEDDemoAdvancedStartOutputtingScreens() {
		if ($DEDDemoAdvanced::SnapshotAt $= "Output Start") {
			if(!isFile("textures/snapshots/" @ $DEDDemoAdvanced::CurrentDemoFile @ ".png")) {
				DEDDemoAdvancedReplaceSnapshot();
			}
		}

		$DEDDemoAdvanced::OutputLock = true;
		$DemoPlaybackIndex = 1;
		if(DemoPlaybackDlg.isAwake())
			Canvas.popDialog(DemoPlaybackDlg);

		if ($DEDDemoAdvanced::ShowCurrentGamma)
			videoSetGammaCorrection( $DEDDemoAdvanced::GammaCorrection );

		recordMovie($DEDDemoAdvanced::ScreenShotsName, $DEDDemoAdvanced::FPS);
	}


	function DEDDemoAdvancedStartOutputtingScreenShots() {
		$DEDDemoAdvanced::OutputtingScreenShots = true;
		
   		%sel = RecordingsDlgList.getSelectedId();
   		%rowText = RecordingsDlgList.getRowTextById(%sel);

		$DEDDemoAdvanced::CurrentDemoFile = "recordings/" @ getField(%rowText,3) @ "" @ getField(%rowText, 0) @ ".rec";
		
     		%val = $DEDDemoAdvanced::CurrentDemoFile @ ".png";
		%valtwo = getSubStr(%val, 11, (strlen(%val) - 19));
		if (StrStr(%valtwo,"/") != -1) {
			%i = Strlen(%valtwo);
			while(%i > 0 && GetSubStr(%valtwo,%i,1) !$= "/") {
				%i--;
			}
		
			if (%i > 0) {
				%fileDir = "Sequenced Images/" @ GetSubStr(%valtwo,0,%i) @ "/";
				$DEDDemoAdvanced = new FileObject();
				$DEDDemoAdvanced.openForWrite(%fileDir);
				$DEDDemoAdvanced.close();
				$DEDDemoAdvanced.delete();
				$DEDDemoAdvanced = "";
			}	
		}

	
		if ($DEDDemoAdvanced::OutputMuteSounds) {
			$DEDDemoAdvanced::PreviousVolume = $pref::Audio::masterVolume;
			alxListenerf( AL_GAIN_LINEAR, 0 );
		}

		$DEDDemoAdvanced::ScreenShotsName = "base/Sequenced Images/" @ %valtwo @ "";
		$DEDDemoAdvanced::OutputStartMatch = msToMinSec($DEDDemoAdvanced::OutputStartTime);
		$DEDDemoAdvanced::OutputFinishMatch = msToMinSec($DEDDemoAdvanced::OutputFinishTime);
		$DEDDemoAdvanced::OutputLock = false;
		StartSelectedDemo();
	}







//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Recording Browser
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function DEDDemoAdvancedDirectoryDropDownFiller() {
		DEDDemoAdvancedDirectoryDropDown.clear();
		
		DEDDemoAdvancedDirectoryDropDown.add( "recordings/", 0, 1 );
		
		for (%i = 0; %i < $DEDDemoAdvanced::NumPathList; %i++) {
			DEDDemoAdvancedDirectoryDropDown.add( "recordings/" @ $DEDDemoAdvanced::PathList[%i], %i+1, 1 );
		}
		
		DEDDemoAdvancedDirectoryDropDown.setSelected(0);
		
		if (DEDDemoAdvancedDirectoryDropDown.getValue() $= "recordings/")
			DEDDemoAdvancedUpDirectoryBtn.setActive(false);
		else
			DEDDemoAdvancedUpDirectoryBtn.setActive(true);

	}

	function DEDDemoAdvancedDirectoryDropDownUpdate(%setTo) {
		if (%setTo !$= "") {
			for (%i = 0; %i < $DEDDemoAdvanced::NumPathList; %i++) {
				if ($DEDDemoAdvanced::PathList[%i] $= %setTo) {
					DEDDemoAdvancedDirectoryDropDown.setSelected(%i+1);
				}
			}
		} else
			DEDDemoAdvancedDirectoryDropDown.setSelected(0);
			
		if (DEDDemoAdvancedDirectoryDropDown.getValue() $= "recordings/")
			DEDDemoAdvancedUpDirectoryBtn.setActive(false);
		else
			DEDDemoAdvancedUpDirectoryBtn.setActive(true);
				
	}
	
	function DEDDemoAdvancedDirectoryDropDown::onSelect( %this, %id, %text ) {
		%pname = GetSubStr(DEDDemoAdvancedDirectoryDropDown.getValue(), 11, StrLen(DEDDemoAdvancedDirectoryDropDown.getValue())-11);
		$DEDDemoAdvanced::CurrentPath = %pname;
			
		RecordingsDlg::fillRecordingsList(RecordingsDlg);
		if (DEDDemoAdvancedDirectoryDropDown.getValue() $= "recordings/")
			DEDDemoAdvancedUpDirectoryBtn.setActive(false);
		else
			DEDDemoAdvancedUpDirectoryBtn.setActive(true);

	}

	function updateRecordingButtons() {
   		%active = RecordingsDlgList.rowCount() != 0;
   
   		if(%active)
      			PR_StartDemoBtn.makeFirstResponder(1);
   		else
      			PR_CancelBtn.makeFirstResponder(1);
	}

	function DEDDemoAdvancedUpdateRecordingList() {
		%val = 0;
		%num = 0;
		
		if ($DEDDemoAdvanced::CurrentPath !$= "") {
			%i = StrLen($DEDDemoAdvanced::CurrentPath)-2;
			%tt = " ";
			
			while (%tt !$= "/" && %i > 0) {
				%tt = GetSubStr($DEDDemoAdvanced::CurrentPath,%i,1);
				%i--;
			}
			
			if (%i >0)			
				%grud = GetSubStr($DEDDemoAdvanced::CurrentPath, 0, %i+2);
			else
				%grud = "";

			RecordingsDlgList.addRow(0, ".." TAB "   " TAB "   " TAB %grud);
			RecordingsDlgList.setRowStyle(%num, 1);
			%num++;
		}
		
		for (%i = 0; %i < $DEDDemoAdvanced::NumPathList; %i++) {
			if (DEDDemoAdvancedCheckDirLevel("recordings/" @ $DEDDemoAdvanced::PathList[%i])) {
				%dirName = $DEDDemoAdvanced::PathList[%i];
				
				%newStr = GetSubStr(%dirName, StrLen($DEDDemoAdvanced::CurrentPath), StrLen(%dirName)-StrLen($DEDDemoAdvanced::CurrentPath));
				%pos = StrStr(%newStr, "/");
				
				if (%pos != -1 || %pos != StrLen(%newStr)-1)
					%dirName = %newStr;
				
				RecordingsDlgList.addRow(%num, %dirName TAB "   " TAB "   " TAB $DEDDemoAdvanced::PathList[%i]);
				RecordingsDlgList.setRowStyle(%num, 1);
				%num++;
			}
		}
		
		return %num;
	}

	function RecordingsDlg::fillRecordingsList(%gui) {
		if(!%gui.initialized) {
      			RecordingsDlgList.setSortColumn(0);
      			RecordingsDlgList.setSortIncreasing(true);

      			RecordingsDlgList.addStyle(1, $ShellFont, $ShellFontSize, "80 220 200", "30 255 225", "10 60 40" );
      			RecordingsDlgList.addStyle(2, $ShellFont, $ShellFontSize, "120 120 120", "120 120 120", "120 120 120" );

			RecordingsDlgList.addColumn(0, "Recording", 200, 100, 300);
			RecordingsDlgList.addColumn(1, "Time", 140, 60, 180, "filetime center");
			RecordingsDlgList.addColumn(2, "Length (min:sec)", 40, 40, 80, "center");
			RecordingsDlgList.addColumn(3, "Path", 1, 1, 1);
      
      			%gui.initialized = true;
		}

   		RecordingsDlgList.clear();
   		RecordingsDlgList.clearList();

		%search = "recordings/*.rec";
		%ct = DEDDemoAdvancedUpdateRecordingList();
		%demoVersion = getDemoVersion();

		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
      			%fileName = fileBase(%file);
      			
      			%var = StrStr(%file, %fileName) - 11;
      			%path = getSubStr(%file, 11, %var);

			if (DEDDemoAdvancedCheckDirLevel(%file)) {
				%val = getDemoVersionLength(%file);
				%version = getField(%val, 0);

				if(%version == -1) {
					%version = "???";
					%length = "???";
				} else
         				%length = msToMinSec(getField(%val, 1));
         				
				%fileTime = getFileModifyTime(%file);
      				RecordingsDlgList.addRow(%ct, %fileName TAB %fileTime TAB %length TAB %path);
				RecordingsDlgList.setRowStyle(%ct, (%version == %demoVersion) ? 1 : 2);
      
				%ct++;
			}
		}

		RecordingsDlgList.sort(0, true);
		RecordingsDlgList.setSelectedRow(0);
	}

	function DEDDemoAdvancedUpdateDetails(){
   		%sel = RecordingsDlgList.getSelectedId();
   		%rowText = RecordingsDlgList.getRowTextById(%sel);

		if (getField(%rowText,2) !$= "   ") {
			%active = RecordingsDlgList.rowCount() != 0;
			PR_StartDemoBtn.setActive(%active);
			PR_DeleteDemoBtn.setActive(%active);
			PR_RenameDemoBtn.setActive(%active);
			DDA_OutputDemoBtn.setActive(%active);
		} else {
			PR_StartDemoBtn.setActive(false);
			PR_DeleteDemoBtn.setActive(false);
			PR_RenameDemoBtn.setActive(false);
			DDA_OutputDemoBtn.setActive(false);
		}
		
		DEDDemoAdvancedUpdateSnapshotPic();
		DEDDemoAdvancedUpdateFilename();	
	}
	
	function DEDDemoAdvancedUpdateFilename(){
   		%sel = RecordingsDlgList.getSelectedId();
   		%rowText = RecordingsDlgList.getRowTextById(%sel);

		if (getField(%rowText,2) !$= "   ") {
			DEDDemoAdvancedFilenameDisplay.setText("Play Demo File:  " @ getField(%rowText, 0) @ ".rec");
		} else {
			%pathName = getField(%rowText,0);
			if (%pathName !$= "..") {
				%pName = GetSubStr(%pathName,0,StrLen(%pathName)-1);
				DEDDemoAdvancedFilenameDisplay.setText("Change Directory to " @ %pName @ "");
			} else 
				DEDDemoAdvancedFilenameDisplay.setText("Back to Previous Directory");
		}
	}

	function DEDDemoAdvancedUpdateSnapshotPic(){
   		%sel = RecordingsDlgList.getSelectedId();
   		%rowText = RecordingsDlgList.getRowTextById(%sel);
   		
   		%temp = $DEDDemoAdvanced::CurrentPath @ getField(%rowText, 0);

   		%snapshotBmp = "snapshots/" @ %temp @ ".png";
   		
	      	if ( !isFile( "textures/" @ %snapshotBmp) ) {
	      		%snapshotBmp = "snapshots/No_Screen.png";
	      		DEDDemoAdvancedScreenMagnify.setVisible(false);
	      	} else
	      		DEDDemoAdvancedScreenMagnify.setVisible(true);

		DEDDemoAdvancedScreenPreview.setBitmap(%snapshotBmp);
		DEDDemoAdvancedFullScreenPictureView.setBitmap(%snapshotBmp);
		
		if (%snapshotBmp !$= "snapshots/No_Screen.png") {
			DEDDemoAdvancedLoadingPicture.setBitmap(%snapshotBmp);
			DEDDemoAdvancedLoadingName.setVisible(true);
			$DDATemp::LoadingPic = %snapshotBmp;
		} else {
			DEDDemoAdvancedLoadingPicture.setBitmap("");
			DEDDemoAdvancedLoadingName.setVisible(false);
			$DDATemp::LoadingPic = "";
		}
	}

	function DEDDemoAdvancedShowFullSnapShot() {
		Canvas.pushdialog(DEDDemoAdvancedFullScreenPicture);
	}

	function RecordingsDlg::onWake(%gui) {
   		%gui.fillRecordingsList();
   		updateRecordingButtons();
  		
  		DEDDemoAdvancedUpdateSnapshotPic();
  		DEDDemoAdvancedUpdateFilename();
  		DEDDemoAdvancedDirectoryDropDownFiller();
		DEDDemoAdvancedSelectFilterBtnFiller();
		
		DEDDemoAdvancedNewFilterBtn.setActive(false);
		DEDDemoAdvancedEditFilterBtn.setActive(false);
		DEDDemoAdvancedDeleteFilterBtn.setActive(false);
		DEDDemoAdvancedSelectFilterBtn.setActive(false);
	}














//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Recording renaming
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function doDemoFileRename() {
		%sel = RecordingsDlgList.getSelectedId();
  		%rowText = RecordingsDlgList.getRowTextById(%sel);
   		
   		if (getField(%rowText,2) !$= "   ") {
   			%file = getField(%rowText,3) @ "" @ getField(%rowText, 0);

   			%newFile = getField(%rowText,3) @ DemoRenameFile_Edit.getValue();
   
   			if(%file $= %newFile)
      				return;

	   		if(%newFile !$= "") {
      				if(renameFile("recordings/" @ %file @ ".rec", "recordings/" @ %newFile @ ".rec")) {
         				rebuildModPaths();
         				RecordingsDlg.fillRecordingsList();
         			
	      				if(isFile("textures/snapshots/" @ %file @ ".png")) {
      						if(renameFile("textures/snapshots/" @ %file @ ".png", "textures/snapshots/" @ %newFile @ ".png")) {
							// Do nothing.
		      				} else
      							echo("Snapshot renaming failed...");
	      				}
	      			
         				return;
      				}
	   		}

   			MessageBoxOK("Rename Failed", "Failed to rename file '" @ %file @ ".rec' to '" @ %newFile @ "'.rec.");
		}
	}
	
	function RenameSelectedDemo() {
		%sel = RecordingsDlgList.getSelectedId();
  		%rowText = RecordingsDlgList.getRowTextById(%sel);
   	
   		if (getField(%rowText,2) !$= "   ") {	
	   		%file = getField(%rowText, 0);

   			DemoRenameFile_Edit.setValue(%file);
   			Canvas.pushDialog(DemoRenameFileDlg);
   		}
	}



















//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Last demo deletion
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function DEDDemoAdvancedDeleteLastDemo() {
		if ($DEDDemoAdvanced::LastDemoFileName[$DEDDemoAdvanced::LastDemoFileNumber] !$= "" && !isRecordingDemo() && !isDemo() && $DEDDemoAdvanced::LastDemoFileNumber > 0) {
			%fName = GetSubStr($DEDDemoAdvanced::LastDemoFileName[$DEDDemoAdvanced::LastDemoFileNumber],0,Strlen($DEDDemoAdvanced::LastDemoFileName[$DEDDemoAdvanced::LastDemoFileNumber])-4);
			messageBoxOkCancel("Delete Recording?", "Are you sure you wish to delete the last demo file 'recordings/" @ $DEDDemoAdvanced::LastDemoFileName[$DEDDemoAdvanced::LastDemoFileNumber] @ "'?", "doLastRecordingDelete(\"" @ %fName @ "\");");
		}
	}
	
	function doLastRecordingDelete(%file) {
		if(deleteFile("recordings/" @ %file @ ".rec")) {
     			if(isFile("textures/snapshots/" @ %file @ ".png")) {
      				if(deleteFile("textures/snapshots/" @ %file @ ".png")) {
      					// do nothing
      				} else
      					echo("Snapshot deletion failed...");
      			}
      			
			addMessageHudLine( "\c4Deleted Last Recording File: \c2" @ $DEDDemoAdvanced::LastDemoFileName[$DEDDemoAdvanced::LastDemoFileNumber] @ "\cr");
			if ($DEDDemoAdvanced::DeleteSound !$= "None" && $DEDDemoAdvanced::EnableAudioAlerts)
				DEDDemoAdvancedPlaySound($DEDDemoAdvanced::DeleteSound);
   		} else 
      			addMessageHudLine( "\c4Failed to Delete Recording File: \c2" @ $DEDDemoAdvanced::LastDemoFileName[$DEDDemoAdvanced::LastDemoFileNumber] @ "\cr");

		$DEDDemoAdvanced::LastDemoFileName[$DEDDemoAdvanced::LastDemoFileNumber] = "";
		$DEDDemoAdvanced::LastDemoFileNumber--;
	}
































//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Filename generation
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function DEDDemoAdvancedFilterIllegalCharacters(%file){
		%varName = "";
		for ( %i = 0;  %i <= strlen(%file); %i++ ) {
			%varChar = getSubStr(%file, %i, 1);
                        if (%varChar !$= "\\" && %varChar !$= "/" && %varChar !$= ":" && %varChar !$= "*" && %varChar !$= ">" && %varChar !$= "<" && %varChar !$= "?") {
				%varName = %varName @ %varChar;
			} else { 
				%varName = %varName @ "";
			}
		}
		
		return %varName;
	}

	function DEDDemoAdvancedGenerateDemoFileName(%val){
		%baseFile = "";
		%xbaseFile = "";
		%sVal = "_";

		if ($DEDDemoAdvanced::TextPrefixDir && $DEDDemoAdvanced::TextPrefixDirText !$= "")
			%baseFile = %baseFile @ "" @ $DEDDemoAdvanced::TextPrefixDirText @ "/";
		
		if ($DEDDemoAdvanced::PlayerNameDir) {
			%pname = getField( $pref::Player[$pref::Player::Current], 0 );
			%baseFile = %baseFile @ "" @ %pname @ "/";
		}
	   		
		if ($DEDDemoAdvanced::ServerNameDir) {
			if (%val > 0) {
				%baseFile = %baseFile @ "" @ MissionCallback.getServerName() @ "/";
			} else {
				%baseFile = %baseFile @ "Tribes 2 Server/";
			}
		}

		if ($DEDDemoAdvanced::ServerModNameDir) {
			if (%val > 0) {
				%baseFile = %baseFile @ "" @ MissionCallback.getServerMod() @ "/";
			} else {
				%baseFile = %baseFile @ "Base/";
			}
		}

		if ($DEDDemoAdvanced::MissionNameDir) {
			if (%val > 0) {
				%baseFile = %baseFile @ "" @ MissionCallback.getMissionName() @ "/";
			} else {
				%baseFile = %baseFile @ "Katabatic/";
			}
		}
			
		if ($DEDDemoAdvanced::GameTypeDir) {
			if (%val > 0) {
				%baseFile = %baseFile @ "" @ MissionCallback.getMissionType() @ "/";
			} else {
				%baseFile = %baseFile @ "CTF/";
			}
		}
   		
		if ($DEDDemoAdvanced::TeamNameDir) {
			if (%val > 0) {
				%baseFile = %baseFile @ "" @ PlayerList.getTeamByID(PlayerList.getMyID()) @ "/";
			} else {
				%baseFile = %baseFile @ "Starwolf/";
			}
		}

		if ($DEDDemoAdvanced::TextPrefix && $DEDDemoAdvanced::TextPrefixText !$= "")
			%xbaseFile = %xbaseFile @ "" @ $DEDDemoAdvanced::TextPrefixText @ %sVal;
			
		if ($DEDDemoAdvanced::PlayerName) {
			%pname = getField( $pref::Player[$pref::Player::Current], 0 );
			%xbaseFile = %xbaseFile @ "" @ %pname @ %sVal;
		}
	   		
		if ($DEDDemoAdvanced::ServerName) {
			if (%val > 0) {
				%xbaseFile = %xbaseFile @ "" @ MissionCallback.getServerName() @ %sVal;
			} else {
				%xbaseFile = %xbaseFile @ "Tribes 2 Server" @ %sVal;
			}
		}

		if ($DEDDemoAdvanced::ServerModName) {
			if (%val > 0) {
				%xbaseFile = %xbaseFile @ "" @ MissionCallback.getServerMod() @ %sVal;
			} else {
				%xbaseFile = %xbaseFile @ "Base" @ %sVal;
			}
		}

		if ($DEDDemoAdvanced::MissionName) {
			if (%val > 0) {
				%xbaseFile = %xbaseFile @ "" @ MissionCallback.getMissionName() @ %sVal;
			} else {
				%xbaseFile = %xbaseFile @ "Katabatic" @ %sVal;
			}
		}
			
		if ($DEDDemoAdvanced::GameType) {
			if (%val > 0) {
				%xbaseFile = %xbaseFile @ "" @ MissionCallback.getMissionType() @ %sVal;
			} else {
				%xbaseFile = %xbaseFile @ "CTF" @ %sVal;
			}
		}
   		
		if ($DEDDemoAdvanced::TeamName) {
			if (%val > 0) {
				%xbaseFile = %xbaseFile @ "" @ PlayerList.getTeamByID(PlayerList.getMyID()) @ %sVal;
			} else {
				%xbaseFile = %xbaseFile @ "Starwolf" @ %sVal;
			}
		}
   			
   		if (%val > 0) {
			$DemoCount = 0;
			for(%found = true; %found; $DemoCount++ ) {
				%suffix = $DemoCount;
				while (strlen(%suffix) < 5) %suffix = "0" @ %suffix;
				%file = %xbaseFile @ "" @ %suffix @ ".rec";
				%found = isFile("recordings/" @ %baseFile @ "" @ %file);
			}
		} else {
			%file = %xbaseFile @ "00000.rec";	
		}
		
		if (%val == 2)
			%finishedFile = %baseFile;
		else if (%val == 3)
			%finishedFile = DEDDemoAdvancedFilterIllegalCharacters(%file);
		else
			%finishedFile = %baseFile @ "" @ DEDDemoAdvancedFilterIllegalCharacters(%file);
		
		return %finishedFile;
	}

	function DEDDemoAdvancedAddTextFlavour(%fName) {
		%fName = "Recordings/" @ %fName;
		%newName = "<lmargin:5>";
		%dirNum = 0;
		
		if (StrStr(%fName,"/") != -1)
			%newName = %newName @ "<color:00dc00><bitmap:DDA_FolderPic> ";
		else	
			%newName = %newName @ "<color:C0C0C0>";		
		
		for (%i=0; %i < StrLen(%fName); %i++) {
			%fChar = GetSubStr(%fName,%i,1);
			if (%fChar $= "/") {
				%dirNum++;
				
				%newName = %newName @ "\n<lmargin:" @ ((%dirNum * 15)-3) @ ">";
				
				if (StrStr(GetSubStr(%fName,%i+1,Strlen(%fName)),"/") != -1)
					%newName = %newName @ "<bitmap:DDA_SubFolderPic> ";
				else
					%newName = %newName @ "<color:C0C0C0><lmargin:" @ ((%dirNum * 15)+12) @ ">";
			} else
				%newName = %newName @ %fChar;
		}
		
		return %newName;
	}
	
	function DEDDemoAdvancedUpdateDemoFilename() {
		%DemoFileName = DEDDemoAdvancedAddTextFlavour(DEDDemoAdvancedGenerateDemoFileName(0));
		DEDDemoAdvanced_FileNameText.setText("" @ %DemoFileName @ " ");
	}










//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Sound Support
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function DEDDemoAdvancedPlaySound(%wavFile) {
		%wavFile = "gui/" @ %wavFile @ ".wav";
		%sender = PlayerList.getMyID();
		%wavLengthMS = alxGetWaveLen(%wavFile);
		if ( $ClientChatHandle[%sender] != 0 )
			alxStop( $ClientChatHandle[%sender] );
					
		$ClientChatHandle[%sender] = alxCreateSource( AudioChat, %wavFile );
		alxPlay( $ClientChatHandle[%sender] );
	}









//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Snapshots
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function DEDDemoAdvancedReplaceSnapshot() {
		if(isFile("textures/snapshots/" @ $DEDDemoAdvanced::CurrentDemoFile @ ".png")) {
			if(deleteFile("textures/snapshots/" @ $DEDDemoAdvanced::CurrentDemoFile @ ".png")) {
					// Do nothing.
			} else {
				echo("Error deleting snapshot");				
			}
		}

		%hudup = false;
		if(DemoPlaybackDlg.isAwake()) {
			%hudup = true;
			Canvas.popDialog(DemoPlaybackDlg);
		}

		DEDDemoAdvancedTakeSnapshot($DEDDemoAdvanced::CurrentDemoFile @ ".png");
		if (%hudup)
			Canvas.pushDialog(DemoPlaybackDlg, 99);
	}

	function DEDDemoAdvancedTakeSnapshot(%val) {
		%valtwo = getSubStr(%val, 11, (strlen(%val) - 19));
		
		if ($DEDDemoAdvanced::NoSnapShotHUDs) {
			Canvas.setContent(PanoramaGui);
			PanoramaGui.beaconsVisible = false;
			if ($cursorControlled) lockMouse(true);
			Canvas.cursorOff();
			Canvas.repaint();
		}

		$pref::interior::showdetailmaps = false;
		
		if (StrStr(%valtwo,"/") != -1) {
			%i = Strlen(%valtwo);
			while(%i > 0 && GetSubStr(%valtwo,%i,1) !$= "/") {
				%i--;
			}
		
			if (%i > 0) {
				%fileDir = "textures/snapshots/" @ GetSubStr(%valtwo,0,%i) @ "/";
				$DEDDemoAdvanced = new FileObject();
				$DEDDemoAdvanced.openForWrite(%fileDir);
				$DEDDemoAdvanced.close();
				$DEDDemoAdvanced.delete();
				$DEDDemoAdvanced = "";
			}	
		}

		$DemoFileSnapshot = "base/textures/snapshots/" @ %valtwo @ ".png";

		screenShot($DemoFileSnapshot);
		
		if ($DEDDemoAdvanced::NoSnapShotHUDs)
			Canvas.setContent(PlayGui);
	}












//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Recording
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------


	function beginDemoRecord(){
		if(isDemo())
      			return;
      			
      		if(isRecordingDemo()) {
      			if (!$DEDDemoAdvanced::ToggleSafetyMode) {
				if ($DEDDemoAdvanced::SafetySound !$= "None" && $DEDDemoAdvanced::EnableAudioAlerts)
					DEDDemoAdvancedPlaySound($DEDDemoAdvanced::SafetySound);

      				addMessageHudLine( "\c4Recording Safety Activated\cr");
      				$DEDDemoAdvanced::ToggleSafetyMode = true;
     			}
      			
      			return;
      		}

	   	stopDemoRecord();

		if ($DEDDemoAdvanced::Prompt) {	   	
			$DEDDemoAdvanced::TempDemoFileName = DEDDemoAdvancedGenerateDemoFileName(3);
			DEDDemoAdvancedFilenamePromptDlg_Edit.setText($DEDDemoAdvanced::TempDemoFileName);
			Canvas.pushdialog(DEDDemoAdvancedFilenamePromptDlg);
		} else {
			$DEDDemoAdvanced::TempDemoFileName = DEDDemoAdvancedGenerateDemoFileName(3);
			beginDemoRecordNextBit();
		}
	}
	
	function beginDemoRecordNextBit(){	
		if(isDemo())
      			return;

		if (!$DEDDemoAdvanced::ToggleSafetyMode && $DEDDemoAdvanced::AutomaticSafetyMode) {
			if ($DEDDemoAdvanced::SafetySound !$= "None" && $DEDDemoAdvanced::EnableAudioAlerts)
				DEDDemoAdvancedPlaySound($DEDDemoAdvanced::SafetySound);

      			addMessageHudLine( "\c4Recording Safety Activated\cr");
      			$DEDDemoAdvanced::ToggleSafetyMode = true;
      		}

		$DemoFileName = DEDDemoAdvancedGenerateDemoFileName(2) @ $DEDDemoAdvanced::TempDemoFileName;
	   	
		$DEDDemoAdvanced::Recording = true;
		if ($DEDDemoAdvanced::StartSound !$= "None" && $DEDDemoAdvanced::EnableAudioAlerts)
			DEDDemoAdvancedPlaySound($DEDDemoAdvanced::StartSound);
			
		if ($DEDDemoAdvanced::ShowRecordHUD) {
			DEDDemoRecordingHudCreate();
			DEDDemoAdvancedFlashRecordingHud();
		}
   			
		if ($DEDDemoAdvanced::TakeSnapshots && $DEDDemoAdvanced::SnapshotAt $= "Recording Start")
			DEDDemoAdvancedTakeSnapshot($DemoFileName);

   		$DemoFile = "recordings/" @ $DemoFileName;

   		addMessageHudLine( "\c4Recording file: \c2" @ $DemoFileName @ "\cr");

   		saveDemoSettings();
   		startRecord($DemoFile);

   		// make sure start worked
   		if(!isRecordingDemo()) {
      			deleteFile($DemoFile);
      			deleteFile($DemoFileSnapshot);
      			addMessageHudLine( "\c3 *** Failed to record file: \c2" @ $DemoFileName @ "\cr");
      			$DEDDemoAdvanced::Recording = false;
			DEDDemoRecordingHudDelete();
			$DemoFile = "";
   		}
	}
	
	function doStopRecording() {
		DEDDemoRecordingHudDelete();
   			
		if ($DEDDemoAdvanced::StopSound !$= "None" && $DEDDemoAdvanced::EnableAudioAlerts)
			DEDDemoAdvancedPlaySound($DEDDemoAdvanced::StopSound);
				
		if ($DEDDemoAdvanced::TakeSnapshots && $DEDDemoAdvanced::SnapshotAt $= "Map End")
			DEDDemoAdvancedTakeSnapshot($DemoFileName);
   			
      		$DEDDemoAdvanced::ToggleSafetyMode = false;
   		$DEDDemoAdvanced::Recording = false;
      		stopRecord();
	}
	
	function stopDemoRecord() {
		if(isDemo())
  			return;
   		
   		if(isRecordingDemo()) {
			if ($DEDDemoAdvanced::ToggleSafetyMode && !$DEDDemoAdvanced::EndOfMap)
				messageBoxOkCancel("Stop Recording?", "Are you sure you wish to stop recording?", "doStopRecording();");
			else
				doStopRecording();
      		}
	}


	function demoRecordComplete() {
   		if($DemoFile !$= "") {
			if ($DEDDemoAdvanced::TakeSnapshots && $DEDDemoAdvanced::SnapshotAt $= "Recording End")
			DEDDemoAdvancedTakeSnapshot($DemoFileName);
      			addMessageHudLine( "\c4Stopped recording file: \c2" @ $DemoFileName @ "\cr.");
      			$DEDDemoAdvanced::LastDemoFileNumber++;
      			$DEDDemoAdvanced::LastDemoFileName[$DEDDemoAdvanced::LastDemoFileNumber] = $DemoFileName;
      			$DemoFile = "";
      			$DemoFileName = "";
   		}
	}










//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Recording playback
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function StartSelectedDemo() {
   		%sel = RecordingsDlgList.getSelectedId();
   		%rowText = RecordingsDlgList.getRowTextById(%sel);
   		if (getField(%rowText,2) !$= "   ") {
   			%file = "recordings/" @ getField(%rowText,3) @ "" @ getField(%rowText, 0) @ ".rec";

   			%verLen = getDemoVersionLength(%file);
   			$DEDDemoAdvanced::CurrentDemoFile = %file;

   			Canvas.pushDialog(DemoLoadProgressDlg);
   		
   			if(playDemo(%file)) {
      				// do not allow new sources to have a force feedback effect
      				alxEnableForceFeedback(false);

      				resetGameState();
      				Canvas.popDialog(DemoLoadProgressDlg);
      				Canvas.popDialog(RecordingsDlg);   
      				Canvas.setContent(PlayGui);
      				loadDemoSettings();

      				$DemoPlaybackIndex = 1;
      				$DemoPlaybackLastIndex = 1;

				GlobalActionMap.bindCmd(keyboard, "escape", "", "stopDemoPlayback();");
				GlobalActionMap.bindCmd(keyboard, "tab", "", "toggleDemoPlaybackHud();");
				GlobalActionMap.bindCmd(keyboard, "space", "", "toggleDemoPause();");
				GlobalActionMap.bindCmd(keyboard, "numpadadd", "", "stepDemoPlaybackSpeed(1);");
				GlobalActionMap.bindCmd(keyboard, "numpadminus", "", "stepDemoPlaybackSpeed(-1);");
				GlobalActionMap.bindCmd(keyboard, "numpad0", "", "DEDDemoAdvancedReplaceSnapshot();");
				GlobalActionMap.bindCmd(keyboard, "numpadenter", "", "SetDemoSpeed(1);");
      				//$globalActionMapOnly = true;

      				$DemoPlaybackProgress = 0;
      				$DemoPlaybackLength = getField(%verLen, 1);
	
      				// playback length may be 0 if recording was not clean (just set to 1min)
      				if($DemoPlaybackLength == 0)
         				$DemoPlaybackLength = 60000;
      
	      			DemoPlayback_EndTime.setValue(msToMinSec($DemoPlaybackLength));
	
      				$DemoPlaybackProgress = 0;
	      			demoPlaybackUpdate(0);

      				updateDemoPlaybackStatus();
   			} else
      				MessageBoxOK("Playback Failed", "Demo playback failed for file '" @ %file @ "'.");

	   		Canvas.popDialog(DemoLoadProgressDlg);
	   	} else {
	   		%pname = getField(%rowText,3);

			$DEDDemoAdvanced::CurrentPath = %pname;
			RecordingsDlg::fillRecordingsList(RecordingsDlg);
			DEDDemoAdvancedDirectoryDropDownUpdate(%pname);
	   	}
	}

	function updateDemoPlaybackStatus() {
		if($DemoPlaybackIndex < -19)
			$DemoPlaybackIndex = -19;

		if($DemoPlaybackIndex > 20)
			$DemoPlaybackIndex = 20;

		if ($DemoPlaybackIndex <= 0) {
			%speedUsed = abs($DemoPlaybackIndex-2);
			%playbackSpeed = (1 / %speedUsed);
			%playbackText = "1 / " @ %speedUsed @ "X Speed";
			
			if ($DemoPlaybackIndex == -19) {
				%playbackSpeed = 0;
				%playbackText = "Paused";
			}
		} else {
			%playbackSpeed = $DemoPlaybackIndex;
			%playbackText = $DemoPlaybackIndex @ "X Speed";
		}

		DemoPlayback_StatusText.setValue(%playbackText);
		$timeScale = %playbackSpeed;
	}

	function demoPlaybackUpdate(%curTime) {
		parent::demoPlaybackUpdate(%curTime);		
		
		if ($DEDDemoAdvanced::OutputtingScreenShots) {
			%convCurTime = msToMinSec(%curTime);
			if (!$DEDDemoAdvanced::OutputLock) {
				//if (%curTime < $DEDDemoAdvanced::OutputStartTime) {
				//	if (%curTime > 4000)
				//		SetDemoSpeed(2);
				//	else if (%curTime > 5000)
				//		SetDemoSpeed(5);
				//	else if (%curTime > 6000)
				//		SetDemoSpeed(10);
				//	else if (%curTime > 7000)
				//		SetDemoSpeed(20);
				//}

				//if (%curTime < $DEDDemoAdvanced::OutputStartTime-5000)
				//	SetDemoSpeed(20);
				//else if (%curTime < $DEDDemoAdvanced::OutputStartTime-4000)
				//	SetDemoSpeed(10);
				//else if (%curTime < $DEDDemoAdvanced::OutputStartTime-3000)
				//	SetDemoSpeed(5);
				//else if (%curTime < $DEDDemoAdvanced::OutputStartTime-2000)
				//	SetDemoSpeed(2);
				//else
				//	SetDemoSpeed(1);
				
				if (%convCurTime $= $DEDDemoAdvanced::OutputStartMatch) {
					echo("Started Outputting at " @ %convCurTime);
					DEDDemoAdvancedStartOutputtingScreens();
				}
			} else {
				%convCurTime = msToMinSec(%curTime);
				if (%convCurTime $= $DEDDemoAdvanced::OutputFinishMatch) {
					echo("Stopped Outputting at " @ %convCurTime);
					DEDDemoAdvancedStopDemoOutputting();
				}
			}
		}
	}

	function stopDemoPlayback() {
		GlobalActionMap.unbind(keyboard, "escape");
		GlobalActionMap.unbind(keyboard, "tab");
		GlobalActionMap.unbind(keyboard, "space");
		GlobalActionMap.unbind(keyboard, "numpadadd");
		GlobalActionMap.unbind(keyboard, "numpadminus");
		GlobalActionMap.unbind(keyboard, "numpad0");
		GlobalActionMap.unbind(keyboard, "numpadenter");

		cancel($screenGrabThread);
		if($DEDDemoAdvanced::OutputLock){
			$DEDDemoAdvanced::OutputLock = false;
			if ($DEDDemoAdvanced::OutputMuteSounds) {
				$pref::Audio::masterVolume = $DEDDemoAdvanced::PreviousVolume;
				alxListenerf( AL_GAIN_LINEAR, $pref::Audio::masterVolume );
			}

			if ($DEDDemoAdvanced::ShowCurrentGamma)
				videoSetGammaCorrection( $pref::OpenGL::gammaCorrection );

			// playsound for demo finish
		}
		$DEDDemoAdvanced::OutputtingScreenShots = false;
		
		parent::stopDemoPlayback();
	}
	
	function SetDemoSpeed(%val) {
		$DemoPlaybackIndex = %val;
	}







//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Recording Loading Screen
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function DemoLoadProgressDlg::onWake(%this){
		parent::onWake(%this);
		%px = firstWord($pref::Video::resolution);
		%py = getWord($pref::Video::resolution, 1);

		DemoLoadProgressDlg.setExtent(%px, %py);
		DEDDemoAdvancedLoadingPicture.setExtent(%px, %py);
		DEDDemoAdvancedLoadingName.setExtent(mfloor((%px / 1024) * 600), mfloor((%py / 768) * 80));
		DDA_BigLoadingTextProfile.setPosition(mfloor((%px / 2) - ((%px/1024) * 50)), mfloor((%py / 2) - ((%py/768) * 36)));
		
		if ($DDATemp::LoadingPic $= "") {
			DemoLoadProgressCtrl.setPosition(mfloor((%px / 1024) * 25), mfloor((%py/2) - ((%py / 768) * 15)));
			DemoLoadProgressCtrl.setExtent(mfloor(%px - ((%px / 1024) * 50)), mfloor((%py / 768) * 30));
		} else {
			DemoLoadProgressCtrl.setPosition(mfloor((%px / 1024) * 5), mfloor(%py - ((%py / 768) * 733)));
			DemoLoadProgressCtrl.setExtent(mfloor(%px - ((%px / 1024) * 10)), mfloor((%py / 768) * 30));
		}
	}






//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Options Screen
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

	function DDA_TabView::onAdd( %this ) {
		%this.addSet( 1, "gui/shll_horztabbuttonB", "5 5 5", "50 50 0", "5 5 5" );
	}

	function DDA_TabView::onSelect( %this, %id, %text ) {
		DDA_NamingPane.setVisible( %id == 1 );
		DDA_RecordingPane.setVisible( %id == 2 );
		DDA_PlaybackPane.setVisible( %id == 3 );
		DDA_AudioPane.setVisible( %id == 4 );
		GM_TabFrame.setAltColor( %this.getTabSet( %id ) != 0 );
	}

	function DEDDemoAdvancedConfigGUI::onWake(%this) {
		if ( DDA_TabView.tabCount() == 0 ) {
       			DDA_TabView.addTab( 1, "NAMING" );
			DDA_TabView.addTab( 2, "RECORDING" );
			DDA_TabView.addTab( 3, "PLAYBACK" );
			DDA_TabView.addTab( 4, "AUDIO" );
   		}

		switch$ ( %this.pane ) {
			case "Audio":
				DDA_TabView.setSelected( 4 );
			case "Playback":
				DDA_TabView.setSelected( 3 );	
			case "Recording":
				DDA_TabView.setSelected( 2 );
			default:
				DDA_TabView.setSelected( 1 );
   		}
	
		DEDDemoAdvancedTextPrefixBtn.setValue( $DEDDemoAdvanced::TextPrefix );
		DEDDemoAdvancedPlayerNameBtn.setValue( $DEDDemoAdvanced::PlayerName );
		DEDDemoAdvancedServerNameBtn.setValue( $DEDDemoAdvanced::ServerName );
		DEDDemoAdvancedMissionNameBtn.setValue( $DEDDemoAdvanced::MissionName );
		DEDDemoAdvancedGameTypeBtn.setValue( $DEDDemoAdvanced::GameType );
		DEDDemoAdvancedTeamNameBtn.setValue( $DEDDemoAdvanced::TeamName );
		DEDDemoAdvancedServerModNameBtn.setValue( $DEDDemoAdvanced::ServerModName );
		
		DEDDemoAdvancedTextPrefixDirBtn.setValue( $DEDDemoAdvanced::TextPrefixDir );
		DEDDemoAdvancedPlayerNameDirBtn.setValue( $DEDDemoAdvanced::PlayerNameDir );
		DEDDemoAdvancedServerNameDirBtn.setValue( $DEDDemoAdvanced::ServerNameDir );
		DEDDemoAdvancedMissionNameDirBtn.setValue( $DEDDemoAdvanced::MissionNameDir );
		DEDDemoAdvancedGameTypeDirBtn.setValue( $DEDDemoAdvanced::GameTypeDir );
		DEDDemoAdvancedTeamNameDirBtn.setValue( $DEDDemoAdvanced::TeamNameDir );
		DEDDemoAdvancedServerModNameDirBtn.setValue( $DEDDemoAdvanced::ServerModDirName );

		DEDDemoAdvancedPromptBtn.setValue( $DEDDemoAdvanced::Prompt );
		DEDDemoAdvancedAutomaticSafetyModeBtn.setValue( $DEDDemoAdvanced::AutomaticSafetyMode );
		DEDDemoAdvancedAlwaysRecordTournamentsBtn.setValue ($DEDDemoAdvanced::AlwaysRecordTournaments );
		DEDDemoAdvancedShowRecordBtn.setValue( $DEDDemoAdvanced::ShowRecordHUD );
		DEDDemoAdvancedShowRecordBlinkBtn.setValue( $DEDDemoAdvanced::ShowRecordHUDBlink );
		DEDDemoAdvancedRecordOnMapStartBtn.setValue( $DEDDemoAdvanced::RecordOnMapStart );
		DEDDemoAdvancedStopAtMapEndBtn.setValue( $DEDDemoAdvanced::StopAtMapEnd );
		DEDDemoAdvancedShowScoresBtn.setValue( $DEDDemoAdvanced::ShowScores );
		DEDDemoAdvancedTakeSnapshotsBtn.setValue( $DEDDemoAdvanced::TakeSnapshots );
		DEDDemoAdvancedNoSnapshotHUDsBtn.setValue( $DEDDemoAdvanced::NoSnapShotHUDs );
		DEDDemoAdvancedSelectTakeSnapshotsBtn.setValue( $DEDDemoAdvanced::SnapshotAt );
		
		DEDDemoAdvanced_RecordingHudSize.setValue( $DEDDemoAdvanced::RecordingHudSize );
		
		$DEDDemoAdvanced::RecordingHudX = mFloor(42 * $DEDDemoAdvanced::RecordingHudSize) -1;
		$DEDDemoAdvanced::RecordingHudY = mFloor(25 * $DEDDemoAdvanced::RecordingHudSize) -1;
		
		DEDDemoAdvancedOnIcon.setExtent($DEDDemoAdvanced::RecordingHudX, $DEDDemoAdvanced::RecordingHudY);

		// Set the Playback Options
		DDA_OutputPanoramaViewBtn.setValue($DEDDemoAdvanced::OutputPanorama);
		DDA_OutputShowTargetsBtn.setValue($DEDDemoAdvanced::OutputShowTargets);
		DDA_OutputShowPotentialTaskBtn.setValue($DEDDemoAdvanced::OutputShowPotentialTask);
		DDA_OutputShowAssignedTaskBtn.setValue($DEDDemoAdvanced::OutputShowAssignedTask);
		DDA_OutputShowClientWaypointBtn.setValue($DEDDemoAdvanced::OutputShowClientWaypoint);
		DDA_OutputShowMissionWaypointBtn.setValue($DEDDemoAdvanced::OutputShowMissionWaypoint);
		DDA_OutputShowBeaconsBtn.setValue($DEDDemoAdvanced::OutputShowBeacons);
		
		// Audio stuff
		DEDDemoAdvancedSelectDeleteSoundBtnFiller();
		DEDDemoAdvancedSelectSafetySoundBtnFiller();
		DEDDemoAdvancedSelectStartSoundBtnFiller();
		DEDDemoAdvancedSelectStopSoundBtnFiller();
		DEDDemoAdvancedSelectStartRecordBtnFiller();
		DEDDemoAdvancedSelectTakeSnapshotsBtnFiller();
		
		DEDDemoAdvancedEnableAudioAlertsBtn.setValue( $DEDDemoAdvanced::EnableAudioAlerts );
		DEDDemoAdvancedToggleAudioAlerts();
		
		DEDDemoAdvancedUpdateDemoFilename();
	}
	
	function DEDDemoAdvancedToggleAudioAlerts() {
		if ($DEDDemoAdvanced::EnableAudioAlerts) {
			DEDDemoAdvancedSelectStartSoundBtn.setActive(true);
			DEDDemoAdvancedSelectStopSoundBtn.setActive(true);
			DEDDemoAdvancedSelectDeleteSoundBtn.setActive(true);
			DEDDemoAdvancedSelectSafetySoundBtn.setActive(true);
			
			if (DEDDemoAdvancedSelectStartSoundBtn.getValue() $= "None")
				DEDDemoAdvancedTestStartSoundBtn.setActive(false);
			else
				DEDDemoAdvancedTestStartSoundBtn.setActive(true);


			if (DEDDemoAdvancedSelectStopSoundBtn.getValue() $= "None")
				DEDDemoAdvancedTestStopSoundBtn.setActive(false);
			else
				DEDDemoAdvancedTestStopSoundBtn.setActive(true);

			
			if (DEDDemoAdvancedSelectDeleteSoundBtn.getValue() $= "None")
				DEDDemoAdvancedTestDeleteSoundBtn.setActive(false);
			else
				DEDDemoAdvancedTestDeleteSoundBtn.setActive(true);
				
				
			if (DEDDemoAdvancedSelectSafetySoundBtn.getValue() $= "None")
				DEDDemoAdvancedTestSafetySoundBtn.setActive(false);
			else
				DEDDemoAdvancedTestSafetySoundBtn.setActive(true);

		} else {
			DEDDemoAdvancedSelectStartSoundBtn.setActive(false);
			DEDDemoAdvancedTestStartSoundBtn.setActive(false);
			DEDDemoAdvancedSelectStopSoundBtn.setActive(false);
			DEDDemoAdvancedTestStopSoundBtn.setActive(false);
			DEDDemoAdvancedSelectDeleteSoundBtn.setActive(false);
			DEDDemoAdvancedTestDeleteSoundBtn.setActive(false);
			DEDDemoAdvancedSelectSafetySoundBtn.setActive(false);
			DEDDemoAdvancedTestSafetySoundBtn.setActive(false);
		}
	}
	
	function DEDDemoAdvancedConfigGUI::onDeactivate(%this) {
		DEDDemoAdvancedSavePrefs();
	}

	function DEDDemoAdvancedConfigGUI::onSleep(%this) {
		DEDDemoAdvancedSavePrefs();
	}

	function DDA_OutputPanoramaViewBtn::onAction(%this) {
		if (%this.getValue)
			%cl = false;
		else
			%cl = true;

		DDA_OutputShowTargetsBtn.setActive(%cl);
		DDA_OutputShowPotentialTaskBtn.setActive(%cl);
		DDA_OutputShowAssignedTaskBtn.setActive(%cl);
		DDA_OutputShowClientWaypointBtn.setActive(%cl);
		DDA_OutputShowMissionWaypointBtn.setActive(%cl);
		DDA_OutputShowBeaconsBtn.setActive(%cl);
	}












	function DisconnectedCleanup() {
		DEDDemoRecordingHudDelete();

		if ($DEDDemoAdvanced::OutputChangeRes && $DEDDemoAdvanced::OutputtingScreenShots) {
			$pref::Video::resolution = $DEDDemoAdvanced::OutputResolution;
			$pref::Video::fullScreen = $DEDDemoAdvanced::OutputFullscreen;
			setScreenMode( firstWord( $DEDDemoAdvanced::OutputResolution ), getWord( $DEDDemoAdvanced::OutputResolution, 1 ),
						   getWord( $DEDDemoAdvanced::OutputResolution, 2 ), $DEDDemoAdvanced::OutputFullscreen );
		}
		
		parent::DisconnectedCleanup();
	}


	
	


	function DEDDemoAdvancedStopAtMapEnd() {
		$DEDDemoAdvanced::EndOfMap = true;
		stopDemoRecord();
		$DEDDemoAdvanced::EndOfMap = false;
	}

	
	function DEDDemoAdvancedGameOver() {
		$DEDDemoAdvanced::TournamentModeCheck = false;
		if ($DEDDemoAdvanced::StopAtMapEnd && !isDemo()) {
			if (!$DEDDemoAdvanced::ShowScores) {
				DEDDemoAdvancedStopAtMapEnd();
			} else {
				schedule( 1000, 0, "DEDDemoAdvancedStopAtMapEnd" );	
			}
		}
	}

	function clientCmdPickTeamMenu( %teamA, %teamB ) {
		parent::clientCmdPickTeamMenu(%teamA, %teamB);
		$DEDDemoAdvanced::TournamentModeCheck = true;
	}

	
	function DEDDemoAdvancedMissionStart(%msgType, %msgString) {
		if (!isDemo() && !isRecordingDemo() && ($DEDDemoAdvanced::RecordOnMapStart || ($DEDDemoAdvanced::AlwaysRecordTournaments && $DEDDemoAdvanced::TournamentModeCheck))) {
			if ($DEDDemoAdvanced::TakeSnapshots && $DEDDemoAdvanced::SnapshotAt $= "Map Start")
				DEDDemoAdvancedReplaceSnapshot();

			beginDemoRecord();
		}
		$DEDDemoAdvanced::TournamentModeCheck = false;
	}

	function DispatchLaunchMode() {
		DEDDemoAdvancedSetup();
      		addMessageCallback('onMissionEnd', DEDDemoAdvancedGameOver);
		addMessageCallBack('onMatchStart', DEDDemoAdvancedMissionStart);
		addMessageCallBack('onUserClientDrop', DEDDemoAdvancedClientDrop);
		
		parent::DispatchLaunchMode();
	}


	function DEDDemoAdvancedEnableAudioAlertsBtn::onAction(%this) {
		DEDDemoAdvancedToggleAudioAlerts();
	}
	
	function DEDDemoAdvancedTextPrefixBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}
	
	function DEDDemoAdvancedPlayerNameBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}

	function DEDDemoAdvancedServerNameBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}

	function DEDDemoAdvancedServerModNameBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}

	function DEDDemoAdvancedMissionNameBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}
	
	function DEDDemoAdvancedGameTypeBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}			

	function DEDDemoAdvancedTeamNameBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}			

	function DEDDemoAdvancedTextPrefixDirBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}

	function DEDDemoAdvancedPlayerNameDirBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}

	function DEDDemoAdvancedServerNameDirBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}

	function DEDDemoAdvancedServerModNameDirBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}

	function DEDDemoAdvancedMissionNameDirBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}
	
	function DEDDemoAdvancedGameTypeDirBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}			

	function DEDDemoAdvancedTeamNameDirBtn::onAction(%this) {
		DEDDemoAdvancedUpdateDemoFilename();
	}			
	
	function DEDDemoAdvancedShowRecordBtn::onAction(%this) {
		if ($DEDDemoAdvanced::ShowRecordHUD)
			DEDDemoRecordingHudCreate();
		else
			DEDDemoRecordingHudDelete();
	}

	function DEDDemoAdvancedSelectTakeSnapshotsBtnFiller() {
		DEDDemoAdvancedSelectTakeSnapshotsBtn.clear();
		
		DEDDemoAdvancedSelectTakeSnapshotsBtn.add( "Map Start", 0, 1 );
		DEDDemoAdvancedSelectTakeSnapshotsBtn.add( "Map End", 1, 1 );
		DEDDemoAdvancedSelectTakeSnapshotsBtn.add( "Recording Start", 2, 1 );
		DEDDemoAdvancedSelectTakeSnapshotsBtn.add( "Recording End", 3, 1 );
		DEDDemoAdvancedSelectTakeSnapshotsBtn.add( "Output Start", 4, 1 );
		DEDDemoAdvancedSelectTakeSnapshotsBtn.add( "Output End", 5, 1 );

		switch$ ( $DEDDemoAdvanced::SnapshotAt ) {
			case "Map Start": %ct = 0;
			case "Map End": %ct = 1;
			case "Recording Start": %ct = 2;
			case "Recording End": %ct = 3;
			case "Output Start": %ct = 4;
			case "Output End": %ct = 5;
			default: %ct = 0;
   		}

		DEDDemoAdvancedSelectTakeSnapshotsBtn.setSelected(%ct);
 	}

	function DEDDemoAdvancedSelectTakeSnapshotsBtn::onSelect( %this, %id, %text ) {
		$DEDDemoAdvanced::SnapshotAt = DEDDemoAdvancedSelectTakeSnapshotsBtn.getValue();
	}


	function DEDDemoAdvancedSelectStartSoundBtn::onSelect( %this, %id, %text ) {
		if (DEDDemoAdvancedSelectStartSoundBtn.getValue() $= "None")
			DEDDemoAdvancedTestStartSoundBtn.setActive(false);
		else
			DEDDemoAdvancedTestStartSoundBtn.setActive(true);
		
		$DEDDemoAdvanced::StartSound = "DDA_" @ DEDDemoAdvancedSelectStartSoundBtn.getValue() @ "_On";
	}
	
	function DEDDemoAdvancedSelectStartSoundBtnFiller() {
		DEDDemoAdvancedSelectStartSoundBtn.clear();
		
		%search = "audio/gui/DDA_*_On.wav";
		
		%findSelected = -1;
		DEDDemoAdvancedSelectStartSoundBtn.add("None", 0, 1 );
		%ct = 1;
		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
			%fileName = fileBase(%file);
			%entry = getSubStr(%fileName,4,(strlen(%fileName) - 7));

			DEDDemoAdvancedSelectStartSoundBtn.add( %entry, %ct, 1 );
			if (%fileName $= $DEDDemoAdvanced::StartSound) {
				%findSelected = %ct;
			}
			
			%ct++;
 		}
 		
		if (%findSelected != -1) 
			DEDDemoAdvancedSelectStartSoundBtn.setSelected(%findSelected);
		else {
			DEDDemoAdvancedTestStartSoundBtn.setActive(false);
			DEDDemoAdvancedSelectStartSoundBtn.setSelected(0);
		}
 	}

 	function DEDDemoAdvancedSelectDeleteSoundBtn::onSelect( %this, %id, %text ) {
		if (DEDDemoAdvancedSelectDeleteSoundBtn.getValue() $= "None")
			DEDDemoAdvancedTestDeleteSoundBtn.setActive(false);
		else
			DEDDemoAdvancedTestDeleteSoundBtn.setActive(true);
 		
		$DEDDemoAdvanced::DeleteSound = "DDA_" @ DEDDemoAdvancedSelectDeleteSoundBtn.getValue() @ "_Del";
	}

 	function DEDDemoAdvancedSelectSafetySoundBtn::onSelect( %this, %id, %text ) {
		if (DEDDemoAdvancedSelectSafetySoundBtn.getValue() $= "None")
			DEDDemoAdvancedTestSafetySoundBtn.setActive(false);
		else
			DEDDemoAdvancedTestSafetySoundBtn.setActive(true);
 		
		$DEDDemoAdvanced::SafetySound = "DDA_" @ DEDDemoAdvancedSelectSafetySoundBtn.getValue() @ "_Saf";
	}
 	
 	function DEDDemoAdvancedSelectStopSoundBtn::onSelect( %this, %id, %text ) {
		if (DEDDemoAdvancedSelectStopSoundBtn.getValue() $= "None")
			DEDDemoAdvancedTestStopSoundBtn.setActive(false);
		else
			DEDDemoAdvancedTestStopSoundBtn.setActive(true);
 		
		$DEDDemoAdvanced::StopSound = "DDA_" @ DEDDemoAdvancedSelectStopSoundBtn.getValue() @ "_Off";
	}

	function DEDDemoAdvancedSelectSafetySoundBtnFiller() {
		DEDDemoAdvancedSelectSafetySoundBtn.clear();
		
		%search = "audio/gui/DDA_*_Saf.wav";
		
		%findSelected = -1;
		DEDDemoAdvancedSelectSafetySoundBtn.add("None", 0, 1 );
		%ct = 1;

		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
			%fileName = fileBase(%file);
			%entry = getSubStr(%fileName,4,(strlen(%fileName) - 8));

			DEDDemoAdvancedSelectSafetySoundBtn.add( %entry, %ct, 1 );
			if (%fileName $= $DEDDemoAdvanced::SafetySound) {
				%findSelected = %ct;
			}
			
			%ct++;
 		}
 		
		if (%findSelected != -1) 
			DEDDemoAdvancedSelectSafetySoundBtn.setSelected(%findSelected);
		else {
			DEDDemoAdvancedTestSafetySoundBtn.setActive(false);
			DEDDemoAdvancedSelectSafetySoundBtn.setSelected(0);
		}
 	}

	function DEDDemoAdvancedSelectDeleteSoundBtnFiller() {
		DEDDemoAdvancedSelectDeleteSoundBtn.clear();
		
		%search = "audio/gui/DDA_*_Del.wav";
		
		%findSelected = -1;
		DEDDemoAdvancedSelectDeleteSoundBtn.add("None", 0, 1 );
		%ct = 1;

		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
			%fileName = fileBase(%file);
			%entry = getSubStr(%fileName,4,(strlen(%fileName) - 8));

			DEDDemoAdvancedSelectDeleteSoundBtn.add( %entry, %ct, 1 );
			if (%fileName $= $DEDDemoAdvanced::DeleteSound) {
				%findSelected = %ct;
			}
			
			%ct++;
 		}
 		
		if (%findSelected != -1) 
			DEDDemoAdvancedSelectDeleteSoundBtn.setSelected(%findSelected);
		else {
			DEDDemoAdvancedTestDeleteSoundBtn.setActive(false);
			DEDDemoAdvancedSelectDeleteSoundBtn.setSelected(0);
		}
 	}

	
	function DEDDemoAdvancedSelectStopSoundBtnFiller() {
		DEDDemoAdvancedSelectStopSoundBtn.clear();
		
		%search = "audio/gui/DDA_*_Off.wav";
		
		%findSelected = -1;
		DEDDemoAdvancedSelectStopSoundBtn.add("None", 0, 1 );
		%ct = 1;
		
		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
			%fileName = fileBase(%file);
			%entry = getSubStr(%fileName,4,(strlen(%fileName) - 8));

			DEDDemoAdvancedSelectStopSoundBtn.add( %entry, %ct, 1 );
			if (%fileName $= $DEDDemoAdvanced::StopSound) {
				%findSelected = %ct;
			}
			
			%ct++;
 		}
 		
		if (%findSelected != -1) 
			DEDDemoAdvancedSelectStopSoundBtn.setSelected(%findSelected);
		else {
			DEDDemoAdvancedTestStopSoundBtn.setActive(false);
			DEDDemoAdvancedSelectStopSoundBtn.setSelected(0);
		}
 	}

	function DEDDemoAdvancedSelectStartRecordBtn::onSelect( %this, %id, %text ) {
		$DEDDemoAdvanced::StartRecord = "DDA_" @ DEDDemoAdvancedSelectStartRecordBtn.getValue() @ "_On";
	}
	
	function DEDDemoAdvancedSelectStartRecordBtnFiller() {
		DEDDemoAdvancedSelectStartRecordBtn.clear();
		
		%search = "textures/gui/DDA_*_On.png";
		
		%findSelected = -1;
		%ct = 0;
		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
			%fileName = fileBase(%file);
			%entry = getSubStr(%fileName,4,(strlen(%fileName) - 7));

			DEDDemoAdvancedSelectStartRecordBtn.add( %entry, %ct, 1 );
			if (%fileName $= $DEDDemoAdvanced::StartRecord) {
				%findSelected = %ct;
			}
			
			%ct++;
 		}
 		
		if (%findSelected != -1) 
			DEDDemoAdvancedSelectStartRecordBtn.setSelected(%findSelected);
		else
			DEDDemoAdvancedSelectStartRecordBtn.setSelected(0);
 	}



	function DemoPlaybackDlg::onWake(%this) {
		DEDDemoAdvanced_CurSpeed.setValue($DemoPlaybackIndex);
   		if(!Canvas.isCursorOn())
			schedule(4,0,"CursorOn");

		updateDemoPlaybackStatus();
	}

 	function DEDDemoAdvanced_SetSpeedSlider() {
		$DemoPlaybackIndex = mFloor( DEDDemoAdvanced_CurSpeed.getValue());
   		updateDemoPlaybackStatus();
 	}
 	
	
 	function toggleDemoPause() {
		if($DemoPlaybackIndex == -19)
			$DemoPlaybackIndex = $DemoPlaybackLastIndex;
		else {
			$DemoPlaybackLastIndex = $DemoPlaybackIndex;
			$DemoPlaybackIndex = -19;
		}

		updateDemoPlaybackStatus();
	}

 	
 	function stepDemoPlaybackSpeed(%step) {
   		$DemoPlaybackIndex += %step;
   		DEDDemoAdvanced_CurSpeed.setValue($DemoPlaybackIndex);
   		updateDemoPlaybackStatus();
	}
	
	function DEDDemoAdvancedSelectFilterBtn::onSelect() {
		$DEDDemoAdvanced::LastFilter = DEDDemoAdvancedSelectFilterBtn.getSelected();	
	}
	
	function DEDDemoAdvancedSelectFilterBtnFiller() {
		DEDDemoAdvancedSelectFilterBtn.clear();

		for(%i = 0; %i <= $DEDDemoAdvanced::NumFilters; %i++ ) {
			if ($DEDDemoAdvanced::FilterList[%i] !$= "") {
				DEDDemoAdvancedSelectFilterBtn.add($DEDDemoAdvanced::FilterList[%i], 0, 1 );
			}
		}
		
		DEDDemoAdvancedSelectFilterBtn.setSelected($DEDDemoAdvanced::LastFilter);
	}

	function DEDDemoAdvancedAddFilter(){
		%fName = DEDDemoAdvancedNewFilter_Edit.getValue();
		
		if (%fName !$= "") {
			$DEDDemoAdvanced::NumFilters++;
		
			$DEDDemoAdvanced::FilterList[$DEDDemoAdvanced::NumFilters] = %fName;
			DEDDemoAdvancedSelectFilterBtn.add( %fName, $DEDDemoAdvanced::NumFilters, 1 );
		
			DEDDemoAdvancedNewFilter_Edit.setValue("");
			Canvas.popDialog(DEDDemoAdvancedNewFilterDlg);
			DEDDemoAdvancedEditFilterFilterName.setText("Filter Name:  " @ %fName @ "");
			Canvas.pushDialog(DEDDemoEditFilterDlg);
		}
	}

	function DEDDemoAdvancedEditFilter() {
		%fName = DEDDemoAdvancedSelectFilterBtn.getValue();
		if (%fName !$= "No Filter") {
			DEDDemoAdvancedEditFilterFilterName.setText("Filter Name:  " @ %fName @ "");
			Canvas.pushDialog(DEDDemoEditFilterDlg);
		}
	}

	function DEDDemoAdvancedDeleteFilter(){
		%search = DEDDemoAdvancedSelectFilterBtn.getValue();
		for(%i = 1; %i <= $DEDDemoAdvanced::NumFilters; %i++ ) {
			if ($DEDDemoAdvanced::FilterList[%i] $= %search)
				$DEDDemoAdvanced::FilterList[%i] = "";
		}
		DEDDemoAdvancedSelectFilterBtnFiller();
	}
	
	function DEDDemoAdvancedFilterMapListFiller(){
		DEDDemoAdvancedFilterMapList.clear();
		
		%search = "missions/*.mis";
		
		DEDDemoAdvancedFilterMapList.add("No Mission Filter", 0, 1 );
		
		%findSelected = -1;
		%ct = 1;
		for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search)) {
			%fileName = fileBase(%file);
			%entry = getSubStr(%fileName,0,strlen(%fileName));

			DEDDemoAdvancedFilterMapList.add( %entry, %ct, 1 );
			%ct++;
 		}
 		
		DEDDemoAdvancedFilterMapList.setSelected(0);
	}
	
	function DEDDemoEditFilterDlg::onWake(%this) {
		DEDDemoAdvancedFilterMapListFiller();
	}
	
	function ScriptBrowserGui::onSleep(%this) {
		DEDDemoAdvancedSavePrefs();
		parent::onSleep(%this);
	}

	function minSecToms(%time) {
		if (GetSubStr(%time,0,1) $= "0") 
			%min = GetSubStr(%time,1,1);
		else
			%min = GetSubStr(%time,0,2);
			
		if (GetSubStr(%time,3,1) $= "0")
			%sec = GetSubStr(%time,4,1);
		else
			%sec = GetSubStr(%time,3,2);
		
		return(((%min * 60) + %sec) * 1000);
	}

	function OutputSelectedDemoDlg::onSleep(%this) {
		DEDDemoAdvancedSavePrefs();
	}
	
	function OutputSelectedDemoDlg::onWake(%this) {
		if (!isDemo) {
			%sel = RecordingsDlgList.getSelectedId();
  			%rowText = RecordingsDlgList.getRowTextById(%sel);

			%fileName = "recordings/" @ getField(%rowText,3) @ "" @ getField(%rowText, 0) @ ".rec";
		
	   		$DEDDemoAdvanced::DemoOutputLength = getField(%rowText,2);
			
			DDA_OutputFinishTimeMinText.setText("00:00");
		} else {
			%version = getDemoVersion();
			%val = getDemoVersionLength($DEDDemoAdvanced::CurrentDemoFile);
			
			if(%version == -1) {
				%version = "???";
				%length = "???";
			} else
        			%length = msToMinSec(getField(%val, 1));

			$DEDDemoAdvanced::DemoOutputLength = %length;
			%time = DemoPlayback_CurTime.getValue();
			DDA_OutputFinishTimeMinText.setText(%time);
		}

		$DEDDemoAdvanced::DemoOutputLengthMS = minSecToms($DEDDemoAdvanced::DemoOutputLength);
		DDA_OutputStartTimeMaxText.setText($DEDDemoAdvanced::DemoOutputLength);
		DDA_OutputFinishTimeMaxText.setText($DEDDemoAdvanced::DemoOutputLength);
   		
		DEDDemoAdvanced_SetStartTimeSlider();
		
		DDA_OutputFPSSlider.setValue($DEDDemoAdvanced::FPS);
		
		DEDDemoAdvancedOutputResolutionBtn.setValue($DEDDemoAdvanced::OutputChangeRes);
		DEDDemoAdvancedOutputMuteSoundsBtn.setValue($DEDDemoAdvanced::OutputMuteSounds);
		DEDDemoAdvancedOutputNoHUDSBtn.setValue($DEDDemoAdvanced::OutputNoHUDS);
		DEDDemoAdvancedOutputResolutionBtn::onAction(DEDDemoAdvancedOutputResolutionBtn);
		DEDDemoAdvancedOutputResolutionBtn.setActive(0);
		
		//DDA_BPPMenu.init(%this.getText());
	}
		
	function DEDDemoAdvancedOutputResolutionBtn::onAction(%this) {
		if (%this.getValue()) {
			DDA_BPPMenu.setActive(true);
			DDA_ResMenu.setActive(true);
		} else {
			DDA_BPPMenu.setActive(false);
			DDA_ResMenu.setActive(false);
		}
	}			

	
 	function DEDDemoAdvanced_SetStartTimeSlider() {
		$DEDDemoAdvanced::OutputStartTime = mfloor(DDA_OutputStartTimeSlider.getValue() * $DEDDemoAdvanced::DemoOutputLengthMS);
		DDA_OutputStartTimeText.setText("Start Time = " @ mstoMinSec($DEDDemoAdvanced::OutputStartTime));
		
		if ($DEDDemoAdvanced::OutputFinishTime < $DEDDemoAdvanced::OutputStartTime) {
			DDA_OutputFinishTimeSlider.setValue(0);
		} else {
			DDA_OutputFinishTimeSlider.setValue(($DEDDemoAdvanced::OutputFinishTime - $DEDDemoAdvanced::OutputStartTime) / ($DEDDemoAdvanced::DemoOutputLengthMS - $DEDDemoAdvanced::OutputStartTime));
		}
		
		DEDDemoAdvanced_SetFinishTimeSlider();
		DDA_OutputFinishTimeMinText.setText(mstoMinSec($DEDDemoAdvanced::OutputStartTime));
 	}

 	function DEDDemoAdvanced_SetFinishTimeSlider() {
		$DEDDemoAdvanced::OutputFinishTime = mfloor($DEDDemoAdvanced::OutputStartTime + DDA_OutputFinishTimeSlider.getValue() * ($DEDDemoAdvanced::DemoOutputLengthMS - $DEDDemoAdvanced::OutputStartTime));
		
		DDA_OutputFinishTimeText.setText("Finish Time = " @ mstoMinSec($DEDDemoAdvanced::OutputFinishTime));
 	}

 	function DEDDemoAdvanced_SetFPSSlider() {
		$DEDDemoAdvanced::FPS = mfloor(DDA_OutputFPSSlider.getValue());
		
		DDA_OutputFPSText.setText("Frames Per Second = " @ $DEDDemoAdvanced::FPS);
 	}
 	
 	function DEDDemoAdvanced_SetGammaSlider() {
		$DEDDemoAdvanced::GammaCorrection = DDA_OutputGammaSlider.getValue();
		if ($DEDDemoAdvanced::ShowCurrentGamma)
			videoSetGammaCorrection( $DEDDemoAdvanced::GammaCorrection );
	}
	
	function DEDDemoAdvancedDefaultGamma() {
		$DEDDemoAdvanced::GammaCorrection = $pref::OpenGL::gammaCorrection;
		DDA_OutputGammaSlider.setValue($DEDDemoAdvanced::GammaCorrection);
		if ($DEDDemoAdvanced::ShowCurrentGamma)
			videoSetGammaCorrection( $DEDDemoAdvanced::GammaCorrection );
	}

	function DEDDemoAdvancedOutputShowGammaBtn::onAction(%this) {
		if (%this.getValue)
			videoSetGammaCorrection( $DEDDemoAdvanced::GammaCorrection );
		else
			videoSetGammaCorrection( $pref::OpenGL::gammaCorrection );
			
		DEDDemoAdvanced_SetGammaSlider();
	}
 	
	function LoadingGui::onWake(%this) {
		if ($DEDDemoAdvanced::OutputChangeRes && $DEDDemoAdvanced::OutputtingScreenShots) {
			setScreenMode( firstWord( $DEDDemoAdvanced::OutputResolution ), getWord( $DEDDemoAdvanced::OutputResolution, 1 ),
					   getWord( $DEDDemoAdvanced::OutputResolution, 2 ), $DEDDemoAdvanced::OutputFullScreen );
		}
		
		parent::onWake(%this);	
	}

	function DDA_BPPMenu::init( %this, %device ) {
		%this.clear();

		if ( %device $= "Voodoo2" )
			%this.add( "16", 0 );
		else {
			%resList = getResolutionList( %device );
			%resCount = getFieldCount( %resList );
			%count = 0;
			for ( %i = 0; %i < %resCount; %i++ ) {
				%bpp = getWord( getField( %resList, %i ), 2 );

				if ( %this.findText( %bpp ) == -1 ) {
					%this.add( %bpp, %count );
					%count++;
				}
			}
		}
	}


};








//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Profiles
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

new GuiControlProfile ("DEDDemoAdvancedBigWhiteText" ) {
	fontType = "Univers Condensed Bold";
	fontSize = 28;
	fontColor = "255 255 255";
	justify = "left";
	autoSizeWidth = true;
	autoSizeHeight = true;
};

new GuiControlProfile ("UpDirectoryButtonProfile") {
	bitmap = "gui/DDA_UpDirectoryButton";
	soundButtonOver = sButtonOver;
	tab = true;
	canKeyFocus = true;
};

new GuiControlProfile ("MakeDirectoryButtonProfile") {
	bitmap = "gui/DDA_MakeDirectoryButton";
	soundButtonOver = sButtonOver;
	tab = false;
	canKeyFocus = true;
};

new GuiControlProfile ("TakeSnapshotButtonProfile") {
	bitmap = "gui/DDA_TakeSnapshotButton";
	soundButtonOver = sButtonOver;
	tab = false;
	canKeyFocus = false;
};

new GuiControlProfile ("MarkStartButtonProfile") {
	bitmap = "gui/DDA_MarkStartButton";
	soundButtonOver = sButtonOver;
	tab = false;
	canKeyFocus = false;
};

new GuiControlProfile ("DDABigLoadingTextProfile") {
	fontType = $ShellHeaderFont;
	fontSize = 28;
	fontColor = "255 255 255";
	justify = "left";
	autoSizeWidth = true;
	autoSizeHeight = true;
};












//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Config GUI
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(DEDDemoAdvancedConfigGUI)) {
	DEDDemoAdvancedConfigGUI.delete();
}

new GuiControl(DEDDemoAdvancedConfigGUI) {
	profile = "GuiDefaultProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 500";
	minExtent = "640 500";
	visible = "1";
	helpTag = "0";
	pane = "Naming";
 
	new ShellScrollCtrl(DEDDemoAdvanced_Scroll) {
		profile = "NewScrollCtrlProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 6";
		extent = "640 500";
		minExtent = "640 500";
		visible = "1";
		helpTag = "0";
		willFirstRespond = "1";
		hScrollBar = "dynamic";
		vScrollBar = "dynamic";
		constantThumbHeight = "0";
		defaultLineHeight = "15";
		childMargin = "0 3";
		fieldBase = "gui/shll_field";

		new GuiBitmapCtrl(DEDDemoAdvancedScriptName) {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "50 0";
			extent = "600 80";
			minExtent = "10 0";
			visible = "1";
			bitmap = "texticons/DDA_TitleGraphic.png";
	      	};

		new ShellTabFrame(DDA_TabFrame) {
			profile = "ShellHorzTabFrameProfile";
			horizSizing = "width";
			vertSizing = "bottom";
			position = "0 104";
			extent = "620 795";
			minExtent = "26 254";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			isVertical = "0";
			useCloseButton = "0";
			edgeInset = "0";
		};
		new ShellTabGroupCtrl(DDA_TabView) {
			profile = "TabGroupProfile";
			horizSizing = "width";
			vertSizing = "bottom";
			position = "8 75";
			extent = "604 600";
			minExtent = "38 29";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			glowOffset = "7";
			tabSpacing = "2";
			maxTabWidth = "150";
			stretchToFit = "0";
		};

		new ShellPaneCtrl(DDA_NamingPane) {
			profile = "ShellDlgPaneProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "10 114";
			extent = "600 425";
			minExtent = "48 92";
			visible = "1";
			helpTag = "0";
			text = "DEMO NAMING CONVENTION";
			maxLength = "255";
			noTitleBar = "0";

			new GuiBitmapCtrl(DEDDemoAdvancedArrowLeft) {
				profile = "GuiDefaultProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "141 63";
				extent = "12 170";
				minExtent = "10 0";
				visible = "1";
				bitmap = "gui/DDA_ArrowLeft.png";
      			};

			new GuiBitmapCtrl(DEDDemoAdvancedArrowRight) {
				profile = "GuiDefaultProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "447 63";
				extent = "12 170";
				minExtent = "10 0";
				visible = "1";
				bitmap = "gui/DDA_ArrowRight.png";
      			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "60 33";
				extent = "10 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Directory";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedTextPrefixDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 50";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::TextPrefixDir";
				helpTag = "0";
				text = "TEXT PREFIX";
				maxLength = "255";
			};		
		
			new ShellToggleButton(DEDDemoAdvancedPlayerNameDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 75";
				extent = "120 30";
				minExtent = "1 1";
				visible = "1";
				variable = "$DEDDemoAdvanced::PlayerNameDir";
				helpTag = "0";
				text = "PLAYER NAME";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedServerNameDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 100";
				extent = "120 30";
				minExtent = "1 1";
				visible = "1";
				variable = "$DEDDemoAdvanced::ServerNameDir";
				helpTag = "0";
				text = "SERVER NAME";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedServerModNameDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 125";
				extent = "120 30";
				minExtent = "1 1";
				visible = "1";
				variable = "$DEDDemoAdvanced::ServerModNameDir";
				helpTag = "0";
				text = "SERVER MOD";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedMissionNameDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 150";
				extent = "120 30";
				minExtent = "1 1";
				visible = "1";
				variable = "$DEDDemoAdvanced::MissionNameDir";
				helpTag = "0";
				text = "MISSION NAME";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedGameTypeDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 175";
				extent = "120 30";
				minExtent = "1 1";
				visible = "1";
				variable = "$DEDDemoAdvanced::GameTypeDir";
				helpTag = "0";
				text = "GAME TYPE";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedTeamNameDirBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 200";
				extent = "120 30";
				minExtent = "1 1";
				visible = "1";
				variable = "$DEDDemoAdvanced::TeamNameDir";
				helpTag = "0";
				text = "TEAM NAME";
				maxLength = "255";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "495 33";
				extent = "10 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Filename:";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedTextPrefixBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 50";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::TextPrefix";
				helpTag = "0";
				text = "TEXT PREFIX";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedPlayerNameBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 75";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::PlayerName";
				helpTag = "0";
				text = "PLAYER NAME";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedServerNameBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 100";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::ServerName";
				helpTag = "0";
				text = "SERVER NAME";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedServerModNameBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 125";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::ServerModName";
				helpTag = "0";
				text = "SERVER MOD";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedMissionNameBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 150";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::MissionName";
				helpTag = "0";
				text = "MISSION NAME";
				maxLength = "255";
			};
		
			new ShellToggleButton(DEDDemoAdvancedGameTypeBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 175";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::GameType";
				helpTag = "0";
				text = "GAME TYPE";
				maxLength = "255";
			};
			
			new ShellToggleButton(DEDDemoAdvancedTeamNameBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "455 200";
				extent = "120 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::TeamName";
				helpTag = "0";
				text = "TEAM NAME";
				maxLength = "255";
			};
			
			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "center";
				vertSizing = "bottom";
				position = "0 33";
				extent = "10 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Example Directory and Filename:";
				longTextBuffer = "0";
				maxLength = "255";
			};
			
       			new ShellScrollCtrl(DEDDemoAdvanced_DemoNameScroll) {
       				profile = "NewScrollCtrlProfile";
       				horizSizing = "width";
       				vertSizing = "height";
       				position = "145 50";
       				extent = "310 155";
       				minExtent = "310 155";
       				visible = "1";
	                        hideCursor = "0";
        	                bypassHideCursor = "0";
        			helpTag = "0";
        			willFirstRespond = "1";
        			hScrollBar = "dynamic";
        			vScrollBar = "dynamic";
        			constantThumbHeight = "0";
        			defaultLineHeight = "15";
        			childMargin = "0 3";
        			fieldBase = "gui/shll_field";

        			new GuiScrollContentCtrl() {
        				profile = "GuiDefaultProfile";
        				horizSizing = "width";
        				vertSizing = "bottom";
        				position = "4 7";
        				extent = "310 155";
        				minExtent = "310 155";
        				visible = "1";
                            		hideCursor = "0";
					bypassHideCursor = "0";
        				helpTag = "0";

        				new GuiMLTextCtrl(DEDDemoAdvanced_FileNameText) {
        					profile = "ShellAltTextProfile";
        					horizSizing = "width";
        					vertSizing = "bottom";
        					position = "0 0";
        					extent = "310 155";
        					minExtent = "310 155";
        					visible = "1";
                                		hideCursor = "0";
                                		bypassHideCursor = "0";
        					helpTag = "0";
        					lineSpacing = "2";
        					allowColorChars = "1";
        					maxChars = "-1";
        				};
        			};
        		};
        		
			new ShellTextEditCtrl(DEDDemoAdvancedTextPrefixDirText_Edit) {
				profile = "NewTextEditProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "145 200";
				extent = "140 30";
				minExtent = "30 30";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				variable = "$DEDDemoAdvanced::TextPrefixDirText";
				maxLength = "255";
				historySize = "0";
				password = "0";
				IRCName = "0";
				tabComplete = "0";
				deniedSound = "InputDeniedSound";
				glowOffset = "9 9";
			};
			
			new ShellTextEditCtrl(DEDDemoAdvancedTextPrefixText_Edit) {
				profile = "NewTextEditProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "315 200";
				extent = "140 30";
				minExtent = "30 30";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				variable = "$DEDDemoAdvanced::TextPrefixText";
				maxLength = "255";
				historySize = "0";
				password = "0";
				IRCName = "0";
				tabComplete = "0";
				deniedSound = "InputDeniedSound";
				glowOffset = "9 9";
			};
			
			new ShellTextEditCtrl(DEDDemoAdvancedTextSeparator_Edit) {
				profile = "NewTextEditProfile";
				horizSizing = "center";
				vertSizing = "bottom";
				position = "0 200";
				extent = "50 30";
				minExtent = "30 30";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				variable = "$DEDDemoAdvanced::TextSeparator";
				maxLength = "255";
				historySize = "0";
				password = "0";
				IRCName = "0";
				tabComplete = "0";
				deniedSound = "InputDeniedSound";
				glowOffset = "9 9";
			};
			
			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "center";
				vertSizing = "bottom";
				position = "0 230";
				extent = "100 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Filename Text Separator";
				longTextBuffer = "0";
				maxLength = "255";
			};

		};

		new ShellPaneCtrl(DDA_RecordingPane) {
			profile = "ShellDlgPaneProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "10 114";
			extent = "600 425";
			minExtent = "48 92";
			visible = "1";
			helpTag = "0";
			text = "RECORDING FEATURES";
			maxLength = "255";
			noTitleBar = "0";

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 33";
				extent = "100 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Recording Icon";
				longTextBuffer = "0";
				maxLength = "255";
			};
		
			new ShellToggleButton(DEDDemoAdvancedShowRecordBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 50";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::ShowRecordHUD";
				helpTag = "0";
				text = "SHOW RECORDING ICON";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedShowRecordBlinkBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 75";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::ShowRecordHUDBlink";
				helpTag = "0";
				text = "FLASH RECORDING ICON";
				maxLength = "255";
			};

			new ShellPopupMenu(DEDDemoAdvancedSelectStartRecordBtn) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "200 46";
				extent = "184 38";
				minExtent = "100 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Select Image";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "210 78";
				extent = "120 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Size:";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new ShellSliderCtrl(DEDDemoAdvanced_RecordingHudSize) {
				profile = "ShellSliderProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "235 75";
				extent = "140 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "value";
				altCommand = "DEDDemoAdvanced_SetRecordingHudSize();";
				helpTag = "0";
				range = "0.2 3.0";
				ticks = "0.0";
				value = "1.6";
				usePlusMinus = "0";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "380 33";
				extent = "100 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Preview Image:";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new GuiBitmapCtrl(DEDDemoAdvancedOnIcon) {
				profile = "GuiDefaultProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "385 56";
				extent = "75 50";
				minExtent = "10 0";
				visible = "1";
				bitmap = "gui/DDA_Basic_On.png";
	      		};	


			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 115";
				extent = "100 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Automated Recording Features";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedPromptBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "righ";
				vertSizing = "bottom";
				position = "220 132";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::Prompt";
				helpTag = "0";
				text = "PROMPT FOR FILENAME";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedAutomaticSafetyModeBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "righ";
				vertSizing = "bottom";
				position = "220 157";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::AutomaticSafetyMode";
				helpTag = "0";
				text = "AUTOMATIC SAFETY MODE";
				maxLength = "255";
			};
			
			new ShellToggleButton(DEDDemoAdvancedRecordOnMapStartBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 132";
				extent = "190 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::RecordOnMapStart";
				helpTag = "0";
				text = "RECORD FROM MAP START";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedStopAtMapEndBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "402 157";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::StopAtMapEnd";
				helpTag = "0";
				text = "STOP AT MAP END";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedAlwaysRecordTournamentsBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 157";
				extent = "190 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::AlwaysRecordTournaments";
				helpTag = "0";
				text = "ALWAYS RECORD TOURNAMENTS";
				maxLength = "255";
			};
			
			new ShellToggleButton(DEDDemoAdvancedShowScoresBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "402 132";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::ShowScores";
				helpTag = "0";
				text = "SHOW SCORES";
				maxLength = "255";
			};


			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 191";
				extent = "100 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Snapshot Features";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new ShellToggleButton(DEDDemoAdvancedTakeSnapshotsBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 208";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::TakeSnapshots";
				helpTag = "0";
				text = "AUTOMATIC SNAPSHOTS";
				maxLength = "255";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "200 212";
				extent = "10 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "AT:";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new ShellPopupMenu(DEDDemoAdvancedSelectTakeSnapshotsBtn) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "217 202";
				extent = "184 38";
				minExtent = "100 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Snapshot At";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};

			new ShellToggleButton(DEDDemoAdvancedNoSnapshotHUDsBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "402 208";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::NoSnapShotHUDs";
				helpTag = "0";
				text = "NO HUDS IN SNAPSHOT";
				maxLength = "255";
			};
	
		};

		new ShellPaneCtrl(DDA_PlaybackPane) {
			profile = "ShellDlgPaneProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "10 114";
			extent = "600 425";
			minExtent = "48 92";
			visible = "1";
			helpTag = "0";
			text = "PLAYBACK FEATURES";
			maxLength = "255";
			noTitleBar = "0";
			
			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 33";
				extent = "100 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Outputting Settings";
				longTextBuffer = "0";
				maxLength = "255";
			};

			new ShellToggleButton(DDA_OutputPanoramaViewBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 50";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::OutputPanorama";
				helpTag = "0";
				text = "PANORAMA VIEW";
				maxLength = "255";
			};
		
			new ShellToggleButton(DDA_OutputShowTargetsBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 75";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::OutputShowTargets";
				helpTag = "0";
				text = "SHOW TARGETS";
				maxLength = "255";
			};

			new ShellToggleButton(DDA_OutputShowPotentialTaskBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 100";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::OutputShowPotentialTask";
				helpTag = "0";
				text = "SHOW POTENTIAL TASKS";
				maxLength = "255";
			};

			new ShellToggleButton(DDA_OutputShowAssignedTaskBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 125";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::OutputShowAssignedTask";
				helpTag = "0";
				text = "SHOW ASSIGNED TASKS";
				maxLength = "255";
			};
			
			new ShellToggleButton(DDA_OutputShowClientWaypointBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 150";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::OutputShowClientWaypoint";
				helpTag = "0";
				text = "SHOW CLIENT WAYPOINTS";
				maxLength = "255";
			};

			new ShellToggleButton(DDA_OutputShowMissionWaypointBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 175";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::OutputShowMissionWaypoint";
				helpTag = "0";
				text = "SHOW MISSION WAYPOINTS";
				maxLength = "255";
			};

			new ShellToggleButton(DDA_OutputShowBeaconsBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 200";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::OutputShowBeacons";
				helpTag = "0";
				text = "SHOW BEACONS";
				maxLength = "255";
			};
		};

		new ShellPaneCtrl(DDA_AudioPane) {
			profile = "ShellDlgPaneProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "10 114";
			extent = "600 225";
			minExtent = "48 92";
			visible = "1";
			helpTag = "0";
			text = "AUDIO ALERTS";
			maxLength = "255";
			noTitleBar = "0";

			new ShellToggleButton(DEDDemoAdvancedEnableAudioAlertsBtn) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 30";
				extent = "170 30";
				minExtent = "26 27";
				visible = "1";
				variable = "$DEDDemoAdvanced::EnableAudioAlerts";
				helpTag = "0";
				text = "ENABLE AUDIO ALERTS";
				maxLength = "255";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "25 58";
				extent = "30 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Recording Start";
				longTextBuffer = "0";
				maxLength = "255";
			};
			
			new ShellBitmapButton(DEDDemoAdvancedTestStartSoundBtn) {
				profile = "SoundTestButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "125 55";
				extent = "24 24";
				minExtent = "24 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "DEDDemoAdvancedPlaySound($DEDDemoAdvanced::StartSound);";
				helpTag = "0";
				simpleStyle = "1";
			};
			
			new ShellPopupMenu(DEDDemoAdvancedSelectStartSoundBtn) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "157 49";
				extent = "184 38";
				minExtent = "100 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Select Sound";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "25 83";
				extent = "30 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Recording Stop";
				longTextBuffer = "0";
				maxLength = "255";
			};
			
			new ShellBitmapButton(DEDDemoAdvancedTestStopSoundBtn) {
				profile = "SoundTestButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "125 80";
				extent = "24 24";
				minExtent = "24 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "DEDDemoAdvancedPlaySound($DEDDemoAdvanced::StopSound);";
				helpTag = "0";
				simpleStyle = "1";
			};
			
			new ShellPopupMenu(DEDDemoAdvancedSelectStopSoundBtn) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "157 74";
				extent = "184 38";
				minExtent = "100 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Select Sound";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "25 108";
				extent = "30 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Recording Deleted";
				longTextBuffer = "0";
				maxLength = "255";
			};
			
			new ShellBitmapButton(DEDDemoAdvancedTestDeleteSoundBtn) {
				profile = "SoundTestButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "125 105";
				extent = "24 24";
				minExtent = "24 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "DEDDemoAdvancedPlaySound($DEDDemoAdvanced::DeleteSound);";
				helpTag = "0";
				simpleStyle = "1";
			};
			
			new ShellPopupMenu(DEDDemoAdvancedSelectDeleteSoundBtn) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "157 99";
				extent = "184 38";
				minExtent = "100 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Select Sound";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};

			new GuiTextCtrl() {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "25 133";
				extent = "30 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Recording Safety";
				longTextBuffer = "0";
				maxLength = "255";
			};
			
			new ShellBitmapButton(DEDDemoAdvancedTestSafetySoundBtn) {
				profile = "SoundTestButtonProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "125 130";
				extent = "24 24";
				minExtent = "24 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "DEDDemoAdvancedPlaySound($DEDDemoAdvanced::SafetySound);";
				helpTag = "0";
				simpleStyle = "1";
			};
			
			new ShellPopupMenu(DEDDemoAdvancedSelectSafetySoundBtn) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "157 124";
				extent = "184 38";
				minExtent = "100 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Select Sound";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};
		};
		
		new ShellBitmapButton(DEDDemoAdvancedConfigClose) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "20 350";
			extent = "180 38";
			minExtent = "32 38";
			visible = "0";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "Canvas.popdialog(DEDDemoAdvancedConfigGUI);DEDDemoAdvancedConfigClose.setVisible(0);";
			accelerator = "escape";
			helpTag = "0";
			text = "CLOSE";
			simpleStyle = "0";
		};


	};
};















//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Demo Playback Dialog
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(DemoPlaybackDlg)) {
	DemoPlaybackDlg.delete();
}

new GuiControl(DemoPlaybackDlg) {
	profile = "GuiModelessDialogProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "0";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl(DEDDemoAdvancedAddCurTimeTo) {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "top";
		position = "0 350";
		extent = "300 105";
		minExtent = "16 18";
		visible = "1";
		helpTag = "0";
		text = "DEMO PLAYBACK";
		maxLength = "255";
		noTitleBar = "0";

		new ShellBitmapButton(DEDDemoAdvancedReplaceSnapshotBtn) {
			profile = "TakeSnapshotButtonProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "20 60";
			extent = "24 24";
			minExtent = "24 24";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvancedReplaceSnapshot();";
			helpTag = "0";
			simpleStyle = "1";
		};

		new ShellBitmapButton(DEDDemoAdvancedMarkStartBtn) {
			profile = "MarkStartButtonProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "44 60";
			extent = "24 24";
			minExtent = "24 24";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "$DemoPlaybackIndex = 0; Canvas.pushdialog(OutputSelectedDemoDlg);";
			helpTag = "0";
			simpleStyle = "1";
		};

		new GuiProgressCtrl() {
			profile = "ShellProgressBarProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "0 37";
			extent = "200 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$DemoPlaybackProgress";
			helpTag = "0";

			new GuiTextCtrl(DemoPlayback_CurTime) {
				profile = "ShellProgressBarTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 2";
				extent = "200 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
			};
		};

		new ShellSliderCtrl(DEDDemoAdvanced_CurSpeed) {
			profile = "ShellSliderProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "0 60";
			extent = "100 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "value";
			altCommand = "DEDDemoAdvanced_SetSpeedSlider();";
			helpTag = "0";
			range = "-19.0 20.0";
			ticks = "100.0";
			value = "1.0";
			usePlusMinus = "0";
		};

		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "67 63";
			extent = "61 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Speed:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		
		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "17 38";
			extent = "31 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "00:00";
			longTextBuffer = "0";
			maxLength = "255";
		};
		
		new GuiTextCtrl(DemoPlayback_EndTime) {
			profile = "ShellTextRightProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "218 38";
			extent = "64 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new GuiTextCtrl(DemoPlayback_StatusText) {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "200 63";
			extent = "64 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
		};
	};
};











//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Recordings GUI
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(RecordingsDlg)) {
	RecordingsDlg.delete();
}

new GuiControl(RecordingsDlg) {
	profile = "DlgBackProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "800 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 0";
		extent = "775 380";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "SELECT RECORDING";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellFancyArrayScrollCtrl() {
			profile = "NewScrollCtrlProfile";
			horizSizing = "right";
			vertSizing = "height";
			position = "23 67";
			extent = "484 236";
			minExtent = "32 32";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			fixedHorizontal = "1";
			vertSpacerBitmap = "gui/shll_vertspacer";
			horzSpacerBitmap = "gui/shll_horzspacer";

			new ShellFancyTextList(RecordingsDlgList) {
				profile = "ShellServerBrowserProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 30";
				extent = "464 232";
				minExtent = "8 20";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				startScrollRegion = "3 0";
				headerBitmap = "gui/server_tabs";
				sortArrowBitmap = "gui/shll_sortarrow";
				fieldBase = "gui/shll_field";
				barBase = "gui/shll_bar";
				glowOffset = "4";
				rowHeight = "19";
				headerFontType = "Univers Condensed";
				headerFontSize = "16";
				headerFontColor = "8 19 6 255";
				headerFontColorHL = "25 68 56 255";
				separatorColor = "192 192 192 255";
				drawSeparators = "0";
				headerSort = "1";
				allowReposition = "1";
				noSelect = "0";
				allowColorChars = "1";
				command = "DEDDemoAdvancedUpdateDetails();";
		            	altCommand = "startSelectedDemo();";
			};
		};
		
		new GuiBitmapCtrl(DEDDemoAdvancedScreenPreview) {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "510 40";
			extent = "240 180";
			minExtent = "0 0";
			visible = "1";
			bitmap = "snapshots/No_Screen.png";
	      	};	

		new GuiBitmapCtrl(DEDDemoAdvancedScreenMagnify) {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "730 200";
			extent = "15 15";
			minExtent = "0 0";
			visible = "0";
			bitmap = "gui/DDA_Magnify.png";
			command = "DEDDemoAdvancedShowFullSnapShot();";
	      	};	

		new GuiBitmapCtrl(DEDDemoAdvancedMiniTitle) {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "510 230";
			extent = "240 32";
			minExtent = "0 0";
			visible = "1";
			bitmap = "texticons/DDA_TitleGraphic.png";
	      	};	
		
		new ShellBitmapButton(PR_CancelBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "400 324";
			extent = "105 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "Canvas.popDialog(RecordingsDlg);";
			accelerator = "escape";
			helpTag = "0";
			text = "CANCEL";
			simpleStyle = "0";
		};
		new ShellBitmapButton(PR_StartDemoBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "20 324";
			extent = "105 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "StartSelectedDemo();";
			helpTag = "0";
			text = "PLAY";
			simpleStyle = "0";
		};
		
		new ShellBitmapButton(DDA_OutputDemoBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "115 324";
			extent = "105 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "Canvas.pushdialog(OutputSelectedDemoDlg);";
			helpTag = "0";
			text = "OUTPUT";
			simpleStyle = "0";
		};
		
		new ShellBitmapButton(PR_DeleteDemoBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "305 324";
			extent = "105 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DeleteSelectedDemo();";
			helpTag = "0";
			text = "DELETE";
			simpleStyle = "0";
		};
		new ShellBitmapButton(PR_RenameDemoBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "210 324";
			extent = "105 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "RenameSelectedDemo();";
			helpTag = "0";
			text = "RENAME";
			simpleStyle = "0";
		};

		new ShellBitmapButton(DEDDemoAdvancedNewFilterBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "505 324";
			extent = "128 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "Canvas.pushDialog(DEDDemoAdvancedNewFilterDlg);";
			helpTag = "0";
			text = "NEW FILTER";
			simpleStyle = "0";
		};
		new ShellBitmapButton(DEDDemoAdvancedDeleteFilterBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "625 324";
			extent = "128 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvancedDeleteFilter();";
			helpTag = "0";
			text = "DELETE FILTER";
			simpleStyle = "0";
		};

		new ShellBitmapButton(DEDDemoAdvancedEditFilterBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "565 298";
			extent = "128 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvancedEditFilter();";
			helpTag = "0";
			text = "EDIT FILTER";
			simpleStyle = "0";
		};
				
		new ShellPopupMenu(DEDDemoAdvancedSelectFilterBtn) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "510 270";
			extent = "240 38";
			minExtent = "100 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Select Demo Filter";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		
		new GuiTextCtrl(DEDDemoAdvancedFilenameDisplay) {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 304";
			extent = "300 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Filename:";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "27 40";
			extent = "50 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Look in:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		
		new ShellPopupMenu(DEDDemoAdvancedDirectoryDropDown) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "64 32";
			extent = "300 38";
			minExtent = "100 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Directory";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		
		new ShellBitmapButton(DEDDemoAdvancedUpDirectoryBtn) {
			profile = "UpDirectoryButtonProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "356 37";
			extent = "24 24";
			minExtent = "24 24";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvancedPreviousDirectory();";
			helpTag = "0";
			simpleStyle = "1";
		};
		
		new ShellBitmapButton(DEDDemoAdvancedMakeDirectoryBtn) {
			profile = "MakeDirectoryButtonProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "378 37";
			extent = "24 24";
			minExtent = "24 24";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvancedMakeDirectory();";
			helpTag = "0";
			simpleStyle = "1";
		};

		new ShellBitmapButton(DDA_OptionsBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "396 30";
			extent = "116 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvancedConfigClose.setVisible(1);Canvas.pushdialog(DEDDemoAdvancedConfigGUI);";
			helpTag = "0";
			text = "OPTIONS";
			simpleStyle = "0";
		};
		
	};
};















//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Make Directory GUI
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(DEDDemoAdvancedMakeDirectoryDlg)) {
	DEDDemoAdvancedMakeDirectoryDlg.delete();
}

new GuiControl(DEDDemoAdvancedMakeDirectoryDlg) {
	profile = "DlgBackProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "170 186";
		extent = "300 146";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Create Directory...";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellTextEditCtrl(DEDDemoAdvancedMakeDirectory_Edit) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "71 39";
			extent = "209 39";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "28 47";
			extent = "48 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Directory:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "28 82";
			extent = "124 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "OK";
			simpleStyle = "0";
         		command = "Canvas.popDialog(DEDDemoAdvancedMakeDirectoryDlg); doMakeDirectory();";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "154 82";
			extent = "124 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "CANCEL";
			simpleStyle = "0";
         		command = "Canvas.popDialog(DEDDemoAdvancedMakeDirectoryDlg);";
		};
	};
};












//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// New Filter GUI
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(DEDDemoAdvancedNewFilterDlg)) {
	DEDDemoAdvancedNewFilterDlg.delete();
}

new GuiControl(DEDDemoAdvancedNewFilterDlg) {
	profile = "DlgBackProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "170 186";
		extent = "300 146";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "New Filter...";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellTextEditCtrl(DEDDemoAdvancedNewFilter_Edit) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "71 39";
			extent = "209 39";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "28 47";
			extent = "48 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Filter:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "28 82";
			extent = "124 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "OK";
			simpleStyle = "0";
         		command = "DEDDemoAdvancedAddFilter();";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "154 82";
			extent = "124 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "CANCEL";
			simpleStyle = "0";
         		command = "Canvas.popDialog(DEDDemoAdvancedNewFilterDlg);";
		};
	};
};















//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Edit Filter GUI
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(DEDDemoEditFilterDlg)) {
	DEDDemoEditFilterDlg.delete();
}

new GuiControl(DEDDemoEditFilterDlg) {
	profile = "GuiModelessDialogProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "0";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl(DEDDemoAdvancedAddStuffTo) {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 0";
		extent = "540 420";
		minExtent = "48 92";
		visible = "1";
		bypassHideCursor = "0";
		hideCursor = "0";
		helpTag = "0";
		text = "EDIT DEMO FILTER";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";
		
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "295 365";
			extent = "128 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "Canvas.popDialog(DEDDemoEditFilterDlg);";
			accelerator = "escape";
			helpTag = "0";
			text = "CANCEL";
			simpleStyle = "0";
		};

		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "95 365";
			extent = "128 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "Canvas.popDialog(DEDDemoEditFilterDlg);";
			accelerator = "enter";
			helpTag = "0";
			text = "ADD FILTER";
			simpleStyle = "0";
		};
		new GuiTextCtrl(DEDDemoAdvancedEditFilterFilterName) {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 36";
			extent = "100 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Filter Name:  " @ $DEDDemoAdvanced::CurrentFilter;
			longTextBuffer = "0";
			maxLength = "255";
		};
		
		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 67";
			extent = "10 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Containing Text:";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellTextEditCtrl(DEDDemoAdvancedFilterTextEditBox) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "120 60";
			extent = "200 30";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$DEDDemoAdvanced::NewFilterText";
			helpTag = "0";
			maxLength = "24";
			historySize = "0";
			password = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};

		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 97";
			extent = "10 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Mission Name:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		
		new ShellPopupMenu(DEDDemoAdvancedFilterMapList) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "120 90";
			extent = "200 38";
			minExtent = "100 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Select Map";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
	};
};






//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Filename prompt GUI
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(DEDDemoAdvancedFilenamePromptDlg)) {
	DEDDemoAdvancedFilenamePromptDlg.delete();
}

new GuiControl(DEDDemoAdvancedFilenamePromptDlg) {
	profile = "DlgBackProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "170 186";
		extent = "300 146";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Change Filename";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellTextEditCtrl(DEDDemoAdvancedFilenamePromptDlg_Edit) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "71 39";
			extent = "209 39";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "28 47";
			extent = "48 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Filename:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "28 82";
			extent = "124 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "OK";
			simpleStyle = "0";
         		command = "$DEDDemoAdvanced::TempDemoFileName = DEDDemoAdvancedFilenamePromptDlg_Edit.getValue();Canvas.popDialog(DEDDemoAdvancedFilenamePromptDlg);beginDemoRecordNextBit();";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "154 82";
			extent = "124 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "CANCEL";
			simpleStyle = "0";
         		command = "Canvas.popDialog(DEDDemoAdvancedFilenamePromptDlg);beginDemoRecordNextBit();";
		};
	};
};








//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Fullscreen snapshot GUI
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(DEDDemoAdvancedFullScreenPicture)) {
	DEDDemoAdvancedFullScreenPicture.delete();
}

new GuiControl(DEDDemoAdvancedFullScreenPicture) {
	profile = "GuiModelessDialogProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "1024 768";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new GuiBitmapCtrl(DEDDemoAdvancedFullScreenPictureView) {
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 0";
		extent = "1024 768";
		minExtent = "0 0";
		visible = "1";
		bitmap = "snapshots/No_Screen.png";
		
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "128 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "Canvas.popdialog(DEDDemoAdvancedFullScreenPicture);";
			accelerator = "escape";
			helpTag = "0";
			text = "CLOSE";
			simpleStyle = "0";
		};
      	};
};












//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Load progress GUI
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(DemoLoadProgressDlg)) {
	DemoLoadProgressDlg.delete();
}

new GuiControl(DemoLoadProgressDlg) {
	profile = "GuiModelessDialogProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = firstWord($pref::Video::resolution) @ " " @ getWord($pref::Video::resolution, 1);
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new GuiBitmapCtrl(DEDDemoAdvancedLoadingPicture) {
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 0";
		extent = firstWord($pref::Video::resolution) @ " " @ getWord($pref::Video::resolution, 1);
		minExtent = "0 0";
		visible = "1";
		bitmap = "";

		new GuiTextCtrl(DDA_BigLoadingTextProfile) {
			profile = "DDABigLoadingTextProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = (mfloor(getword(DEDDemoAdvancedLoadingPicture.extent, 0)/2)-50) @ " " @ (getword(DEDDemoAdvancedLoadingPicture.extent, 1) - 36);
			extent = "100 40";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Loading";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new GuiBitmapCtrl(DEDDemoAdvancedLoadingName) {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "0 0";
			extent = "600 80";
			minExtent = "10 0";
			visible = "1";
			bitmap = "texticons/DDA_TitleGraphic.png";
	      	};
		
		new GuiProgressCtrl(DemoLoadProgressCtrl) {
			profile = "ShellProgressBarProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "5 733";
			extent = (getword(DEDDemoAdvancedLoadingPicture.extent, 0)-10) @ " 30";
			minExtent = "32 15";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			glowOffset = "9 9";
		};
      	};
};





















//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Output sequenced image GUI
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

if (isObject(OutputSelectedDemoDlg)) {
	OutputSelectedDemoDlg.delete();
}

new GuiControl(OutputSelectedDemoDlg) {
	profile = "DlgBackProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl(DDA_SequencedImagesMain) {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 0";
		extent = "500 400";
		minExtent = "16 18";
		visible = "1";
		helpTag = "0";
		text = "OUTPUT SEQUENCED IMAGES";
		maxLength = "255";
		noTitleBar = "0";

		new ShellBitmapButton(DDA_OutputOutput) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "40 340";
			extent = "180 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvancedStartOutputtingScreenShots();";
			helpTag = "0";
			text = "OUTPUT";
			simpleStyle = "0";
		};

		new ShellBitmapButton(DDA_OutputExit) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "280 340";
			extent = "180 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "Canvas.popdialog(OutputSelectedDemoDlg);";
			helpTag = "0";
			text = "EXIT";
			simpleStyle = "0";
		};

		new GuiTextCtrl(DDA_OutputStartTimeText) {
			profile = "ShellTextProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "0 35";
			extent = "50 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Start Time = 00:00";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new GuiTextCtrl(DDA_OutputStartTimeMinText) {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "20 53";
			extent = "20 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "00:00";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new GuiTextCtrl(DDA_OutputStartTimeMaxText) {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "450 53";
			extent = "20 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "00:00";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellSliderCtrl(DDA_OutputStartTimeSlider) {
			profile = "ShellSliderProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "50 50";
			extent = "400 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "value";
			altCommand = "DEDDemoAdvanced_SetStartTimeSlider();";
			helpTag = "0";
			range = "0.0 1.0";
			ticks = "1.0";
			value = "0.0";
			usePlusMinus = "0";
		};
		
		
		new GuiTextCtrl(DDA_OutputFinishTimeText) {
			profile = "ShellTextProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "0 85";
			extent = "50 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Finish Time = 00:00";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new GuiTextCtrl(DDA_OutputFinishTimeMinText) {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "20 103";
			extent = "20 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "00:00";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new GuiTextCtrl(DDA_OutputFinishTimeMaxText) {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "450 103";
			extent = "20 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "00:00";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellSliderCtrl(DDA_OutputFinishTimeSlider) {
			profile = "ShellSliderProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "50 100";
			extent = "400 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "value";
			altCommand = "DEDDemoAdvanced_SetFinishTimeSlider();";
			helpTag = "0";
			range = "0.0 1.0";
			ticks = "1.0";
			value = "0.0";
			usePlusMinus = "0";
		};


		new GuiTextCtrl(DDA_OutputFPSText) {
			profile = "ShellTextProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "0 135";
			extent = "50 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Frames Per Second = 1";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new GuiTextCtrl(DDA_OutputFPSMinText) {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "40 153";
			extent = "20 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "1";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new GuiTextCtrl(DDA_OutputFPSMaxText) {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "450 153";
			extent = "20 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "100";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellSliderCtrl(DDA_OutputFPSSlider) {
			profile = "ShellSliderProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "50 150";
			extent = "400 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "value";
			altCommand = "DEDDemoAdvanced_SetFPSSlider();";
			helpTag = "0";
			range = "1.0 100.0";
			ticks = "1.0";
			value = "0.0";
			usePlusMinus = "0";
		};

		new GuiTextCtrl(DDA_OutputGammaText) {
			profile = "ShellTextProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "0 185";
			extent = "50 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Output Gamma Correction";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellSliderCtrl(DDA_OutputGammaSlider) {
			profile = "ShellSliderProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 200";
			extent = "200 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "value";
			altCommand = "DEDDemoAdvanced_SetGammaSlider();";
			helpTag = "0";
			range = "0.000000 1.000000";
			ticks = "1000";
			value = "0.385965";
			usePlusMinus = "1";
		};

		new ShellToggleButton(DEDDemoAdvancedOutputShowGammaBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "260 205";
			extent = "100 30";
			minExtent = "26 27";
			visible = "1";
			variable = "$DEDDemoAdvanced::ShowCurrentGamma";
			helpTag = "0";
			text = "SHOW GAMMA";
			maxLength = "255";
		};
		
		new ShellBitmapButton(DEDDemoAdvancedDefaultGammaBtn) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "360 200";
			extent = "100 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "DEDDemoAdvancedDefaultGamma();";
			helpTag = "0";
			text = "DEFAULT";
			simpleStyle = "0";
		};

		new ShellToggleButton(DEDDemoAdvancedOutputResolutionBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "20 235";
			extent = "180 30";
			minExtent = "26 27";
			visible = "1";
			variable = "$DEDDemoAdvanced::OutputChangeRes";
			helpTag = "0";
			text = "CHANGE OUTPUT RESOLUTION";
			maxLength = "255";
		};

		new ShellPopupMenu(DDA_ResMenu) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "200 230";
			extent = "160 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Select Resolution";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new ShellPopupMenu(DDA_BPPMenu) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "350 230";
			extent = "130 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Default";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};

		new ShellToggleButton(DEDDemoAdvancedOutputMuteSoundsBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "60 315";
			extent = "180 30";
			minExtent = "26 27";
			visible = "1";
			variable = "$DEDDemoAdvanced::OutputMuteSounds";
			helpTag = "0";
			text = "MUTE OUTPUT SOUNDS";
			maxLength = "255";
		};

		new ShellToggleButton(DEDDemoAdvancedOutputNoHUDSBtn) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "250 315";
			extent = "180 30";
			minExtent = "26 27";
			visible = "1";
			variable = "$DEDDemoAdvanced::OutputNoHUDS";
			helpTag = "0";
			text = "NO HUDS IN OUTPUT";
			maxLength = "255";
		};
	};
};






//---------------------------------------------------------------------
//---------------------------------------------------------------------
//
// Activate package
//
//---------------------------------------------------------------------
//---------------------------------------------------------------------

activatepackage(DEDDemoAdvanced);